/*
===============================================================================
  GkGraphics.s :  fjCu[ OtBbNX֘A
===============================================================================

	Copyright (C) 2007-2012  Masahiko Watanabe
	Revision Id.:  Rev.2012.04.24

-----------------------------------------------------------------------------*/


function ::GK.Graphics.Construct( hdc )
{
	.hdc = hdc;
	#px "--- gc \z", .hdc;
}

function ::GK.Graphics.Destruct()
{
	#px "--- gc j", .hdc;
	if( .hdc != null )
	{
		.ResetPaintConds();
		//^ReleaseDC( ..., .hdc );	//  #CS_OWNDC  ^GetDC() ꍇ͕sv
		.hdc = null;
	}
}

function ::GK.Graphics.ResetPaintConds()
{
	if( ._hDefPen )		^SelectObject( .hdc, ._hDefPen );
	if( ._hDefBrush )	^SelectObject( .hdc, ._hDefBrush );
	if( ._hDefFont )	^SelectObject( .hdc, ._hDefFont );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.GetCaps( ix )
{
	return ^GetDeviceCaps( .hdc, ix );
}

function ::GK.Graphics.SetMapMode( mode )
{
	return ^SetMapMode( .hdc, mode );
}

function ::GK.Graphics.SetPen( pen )
{
	h = ^SelectObject( .hdc, pen.hPen );
	if( ! ._hDefPen'exist? )
		._hDefPen = h;
	//._CurPen := pen;
}

function ::GK.Graphics.SetBrush( brush )
{
	h = ^SelectObject( .hdc, brush.hBrush );
	if( ! ._hDefBrush'exist? )
		._hDefBrush = h;
	//._CurBrush := brush;
}

function ::GK.Graphics.SetFont( font )
{
	h = ^SelectObject( .hdc, font.hFont );
	if( ! ._hDefFont'exist? )
		._hDefFont = h;
	//._CurFont := font;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.SetTextColor( c )	{  ^SetTextColor( .hdc, c );  }
function ::GK.Graphics.SetBackColor( c )	{  ^SetBkColor( .hdc, c );  }
function ::GK.Graphics.SetBackMode( m )		{  ^SetBkMode( .hdc, m );  }
function ::GK.Graphics.SetTextAlign( m )	{  ^SetTextAlign( .hdc, m );  }
function ::GK.Graphics.SetCharSpace( d )	{  ^SetTextCharacterExtra( .hdc, d );  }
function ::GK.Graphics.SetTxAdjust( s, n )	{  ^SetTextJustification( .hdc, s, n );  }
function ::GK.Graphics.SetROP2( m )			{  ^SetROP2( .hdc, m );  }
function ::GK.Graphics.SetStretchBltMode(m)	{  ^SetStretchBltMode( .hdc, m );  }
function ::GK.Graphics.SetBrushOrg( x, y )	{  ^SetBrushOrgEx( .hdc, x, y, #NULL );  }
function ::GK.Graphics.SetGraphicsMode( m )	{  return ^SetGraphicsMode( .hdc, m );  }
function ::GK.Graphics.SetPolyFillMode( m )	{  ^SetPolyFillMode( .hdc, m );  }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.SetViewportExt( x, y )
{
	^SetViewportExtEx( .hdc, x, y, #NULL );
}

function ::GK.Graphics.SetWindowExt( x, y )
{
	^SetWindowExtEx( .hdc, x, y, #NULL );
}

function ::GK.Graphics.SetViewportOrg( x, y )
{
	^SetViewportOrgEx( .hdc, x, y, #NULL );
}

function ::GK.Graphics.SetWindowOrg( x, y )
{
	^SetWindowOrgEx( .hdc, x, y, #NULL );
}

function ::GK.Graphics.DPtoLP( x, y )
{
	@P'LONG(2) = { x, y };
	^DPtoLP( .hdc, @P, 1 );
	x = @P(0);
	y = @P(1);
}

function ::GK.Graphics.LPtoDP( x, y )
{
	@P'LONG(2) = { x, y };
	^LPtoDP( .hdc, @P, 1 );
	x = @P(0);
	y = @P(1);
}

function ::GK.Graphics.SetTransform( xform )
{
	return ^SetWorldTransform( .hdc, xform'addr );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.SaveDC()		{  ^SaveDC( .hdc );  }
function ::GK.Graphics.RestoreDC()	{  ^RestoreDC( .hdc, -1 );  }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.SetPixel( x, y, c )	{  ^SetPixelV( .hdc, x, y, c );  }
function ::GK.Graphics.GetPixel( x, y )		{  return ^GetPixel( .hdc, x, y );  }

function ::GK.Graphics.MoveTo( x, y )		{  ^MoveToEx( .hdc, x, y, #NULL );  }
function ::GK.Graphics.LineTo( x, y )		{  ^LineTo( .hdc, x, y );  }

function ::GK.Graphics.ClearRect( R, color )	// `wFœhׂ
{												// iFw薳Ȃ猻uVgpj
	if(( c = color ) != null )
		ho = ^SelectObject( .hdc, hc = ^CreateSolidBrush( c ) );
	^PatBlt( .hdc, R.Xo, R.Yo, R.Xd, R.Yd, #PATCOPY );
	if( c != null )
	{
		^SelectObject( .hdc, ho );
		^DeleteObject( hc );
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.FrameRect( R )	// `̘gijyŕ`
{
	//( Xo, Yo ) = ( R.Xo, R.Yo );
	//( Xe, Ye ) = ( Xo + R.Xd - 1, Yo + R.Yd - 1 );
	//.MoveTo( Xo, Yo );
	//.LineTo( Xe, Yo );
	//.LineTo( Xe, Ye );
	//.LineTo( Xo, Ye );
	//.LineTo( Xo, Yo );

	P'LONG(10);
	#set	Px(i)	P(#i*2)
	#set	Py(i)	P(#i*2+1)
	#Px(0) = #Px(3) = #Px(4) = R.Xo;
	#Py(0) = #Py(1) = #Py(4) = R.Yo;
	#Px(1) = #Px(2) = R.Xo + R.Xd - 1;
	#Py(2) = #Py(3) = R.Yo + R.Yd - 1;
	^Polyline( .hdc, P, 5 );
}

function ::GK.Graphics.DrawRect( R )	// `̘gyœuVŕ`
{
	^Rectangle( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.FrameOval( R )	// ȉ~̘gyŕ`
{
	h = ^SelectObject( .hdc, ^GetStockObject( #NULL_BRUSH ) );
	^Ellipse( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
	^SelectObject( .hdc, h );
}

function ::GK.Graphics.DrawOval( R )	// ȉ~̘gyœuVŕ`
{
	^Ellipse( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.FrameRRect( R )	// pۋ`̘gyŕ`
{
	h = ^SelectObject( .hdc, ^GetStockObject( #NULL_BRUSH ) );
	^RoundRect( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd, R.Rx, R.Ry );
	^SelectObject( .hdc, h );
}

function ::GK.Graphics.DrawRRect( R )	// pۋ`̘gyœuVŕ`
{
	^RoundRect( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd, R.Rx, R.Ry );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.DrawArc( R )		// ȉ~ʂ̘gyŕ`
{
	^RadialPoint( R, X1'new, Y1'new, X2'new, Y2'new );
	^Arc( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd, X1, Y1, X2, Y2 );
}

function ::GK.Graphics.DrawPie( R )		// `̘gyœuVŕ`
{
	^RadialPoint( R, X1'new, Y1'new, X2'new, Y2'new );
	^Pie( .hdc, R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd, X1, Y1, X2, Y2 );
}

function	RadialPoint( R, X1, Y1, X2, Y2 )
{
	Xc = R.Xo + R.Xd / 2;	// ȉ~̒ŜW
	Yc = R.Yo + R.Yd / 2;	// ȉ~̒ŜW

	t = R.Ao * ^DegToRad;	// n_̊pxivłOOxj
	X2 = ( Xc + 0x1000 * ::sin( t ))'int;
	Y2 = ( Yc - 0x1000 * ::cos( t ))'int;

	t = ( R.Ao + R.Ad ) * ^DegToRad;	// I_̊px
	X1 = ( Xc + 0x1000 * ::sin( t ))'int;
	Y1 = ( Yc - 0x1000 * ::cos( t ))'int;

	if( R.Ad < 0 )	// vH
	{
		t = X1;  X1 = X2;  X2 = t;
		t = Y1;  Y1 = Y2;  Y2 = t;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.FramePolygon( V )	// p`̘gyŕ`
{
	h = ^SelectObject( .hdc, ^GetStockObject( #NULL_BRUSH ) );
	^Polygon( .hdc, V.P, V.N );
	^SelectObject( .hdc, h );
}

function ::GK.Graphics.DrawPolygon( V )		// p`̘gyœuVŕ`
{
	^Polygon( .hdc, V.P, V.N );
}

function ::GK.Graphics.Polyline( V )		// w̓_QԒ`
{
	^Polyline( .hdc, V.P, V.N );
}

function ::GK.Graphics.BezierCurve( V )		// xWFȐ`
{
	^PolyBezier( .hdc, V.P, V.N );
}

function ::GK.Graphics.BezierTo( V )		// ݓ_N_ƂăxWFȐ`
{
	^PolyBezierTo( .hdc, V.P, V.N );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.DrawString( x, y, text, TabXp, TabXo )
//  ӁF
//	  TabXp : e^u~ʒûwWl̔zi 'LONG ̏zŎwv j
//	  TabXo : ^uWJ̊_wWl
{
	if( TabXp == null )
		^TextOut( .hdc, x, y, text, text'cn );
	else
		^TabbedTextOut( .hdc, x, y, text, text'cn, TabXp'count, TabXp, TabXo );
}

function ::GK.Graphics.DrawChars( x, y, cp, cn, rp, dxp )
//  ӁF
//	  rp  : Nbv̈ RECT ̏z
//	  dxp : e̊Ԋu LONG ̏z
{
	if( cn == null )
		cn := cp'cn;
	^ExtTextOut( .hdc, x, y, .ExtTextMode, rp, cp, cn, dxp );
}

function ::GK.Graphics.DrawText( R, text, mode )
{
	if( ! @R'exist? )
		@R'LONG(4);
	if( R )
		@R = {  R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd  };
	else
		@R = {  0, 0, .Xd, .Yd  };
	if(( m = mode ) == null )
		m = #DT_CENTER | #DT_VCENTER | #DT_SINGLELINE;
	^DrawText( .hdc, text, -1, @R, m );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.GetCharsExtent( cp, cn, MaxXd, FitCn, pCXd )
//  ӁF
//	  MaxXd: ő啝i FitCn ȗ͖ j
//	  FitCn: ő啝Ɏ܂镶̃R[hi[鐮ϐiȗj
//	  pCXd : 擪e܂ł̋i[ LONG ̏ziȗj
//  ԒlF
//	  ő啝Ɏ܂镶̕ƍi펞jor -1iG[j
{
	if( cn == null )
		cn := cp'cn;

	pFitCn = ( FitCn'type == "integer" ) ? FitCn'addr : null;

	if( ! @DxDy'exist? )
		@DxDy'LONG(2);

	if( ^GetTextExtentExPoint( .hdc, cp, cn, MaxXd, pFitCn, pCXd, @DxDy ) )
		return ( @DxDy(0), @DxDy(1) );	//i c̎AKv j
	else
		return -1;
}

function ::GK.Graphics.SetTextJusty( bx, bn )
{
	^SetTextJustification( .hdc, bx, bn );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.DrawEdge( R, edge, side )
{
	if( ! @RECT'exist? )	@RECT 'LONG(4);
	@RECT(0) = R.Xo;
	@RECT(1) = R.Yo;
	@RECT(2) = R.Xo + R.Xd;
	@RECT(3) = R.Yo + R.Yd;
	^DrawEdge( .hdc, @RECT, edge, side );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.DrawFrameControl( R, type, state )
{
	if( ! @RECT'exist? )	@RECT 'LONG(4);
	@RECT(0) = R.Xo;
	@RECT(1) = R.Yo;
	@RECT(2) = R.Xo + R.Xd;
	@RECT(3) = R.Yo + R.Yd;
	^DrawFrameControl( .hdc, @RECT, type, state );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.DrawIcon( x, y, icon )
{
	^DrawIconEx( .hdc, x, y, icon.hIcon, 0, 0, 0, #NULL, #DI_NORMAL );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.FrameRegion( R, color )	// ̘̈gwFŕ`
{
	hBrush = ^CreateSolidBrush( color );
	^FrameRgn( .hdc, R.hRgn, hBrush, 1, 1 );
	^DeleteObject( hBrush );
}

function ::GK.Graphics.FillRegion( R, brush )	// ̈̓wuVŕ`
{
	^FillRgn( .hdc, R.hRgn, brush.hBrush );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.PointsToDots( pnt )
{
	return ::Math.round( pnt'float * ^GetDeviceCaps( .hdc, #LOGPIXELSY ) / 72 )'int;
}

function ::GK.Graphics.GetFontInfo()
{
	delete .FontInfo;
	.FontInfo ::=
	{
		.Height				'LONG;
		.Ascent				'LONG;
		.Descent			'LONG;
		.InternalLeading	'LONG;
		.ExternalLeading	'LONG;
		.AveCharWidth		'LONG;
		.MaxCharWidth		'LONG;
		.Weight				'LONG;
		.Overhang			'LONG;
		.DigitizedAspectX	'LONG;
		.DigitizedAspectY	'LONG;
		.FirstChar			'T(1);
		.LastChar			'T(1);
		.DefaultChar		'T(1);
		.BreakChar			'T(1);
		.Italic				'BYTE;
		.Underlined			'BYTE;
		.StruckOut			'BYTE;
		.PitchAndFamily		'BYTE;
		.CharSet			'BYTE; 
	}
	FontMetrics = ::Buffer( sz = .FontInfo'size );
	FontMetrics.Keep( sz );
	^GetTextMetrics( .hdc, FontMetrics );
	FontMetrics.Read( .FontInfo );

	FontName'USHORT( #LF_FACESIZE );
	^GetTextFace( .hdc, #LF_FACESIZE, FontName );
	.FontInfo.Name = FontName'gets;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.SetClip( R )
{
	switch( R'type )
	{
	  case "Rect":
		hRgn = ^CreateRectRgn( R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
		break;
	  case "Oval":
		hRgn = ^CreateEllipticRgn( R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
		break;
	  case "RRect":
		hRgn = ^CreateRoundRectRgn( R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd, R.Rx, R.Ry );
		break;
	  case "Polygon":
		hRgn = ^CreatePolygonRgn( R.P, R.N, R.alt? ? #ALTERNATE : #WINDING );
		break;
	  case "Region":
		^SelectClipRgn( .hdc, R.hRgn );
		return;
	  case "null":		// NbsOȂ
		^SelectClipRgn( .hdc, #NULL );
		return;
	}
	^SelectClipRgn( .hdc, hRgn );
 	^DeleteObject( hRgn );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.DrawBitmap( bmp, dst, src, mode )
{
	if(( srcXo = src.Xo ) == null )	 srcXo = 0;
	if(( srcYo = src.Yo ) == null )	 srcYo = 0;
	if(( srcXd = src.Xd ) == null )	 srcXd = bmp.Xd;
	if(( srcYd = src.Yd ) == null )	 srcYd = bmp.Yd;

	if(( dstXo = dst.Xo ) == null )	 dstXo = 0;
	if(( dstYo = dst.Yo ) == null )	 dstYo = 0;
	if(( dstXd = dst.Xd ) == null )	 dstXd = srcXd;
	if(( dstYd = dst.Yd ) == null )	 dstYd = srcYd;

	if( mode'type != "integer" )
		mode := #SRCCOPY;

	if( bmp.Yd > 0 )	// _H
		srcYo = bmp.Yd - srcYo - srcYd;

	^StretchDIBits(
		.hdc,		// handle to device context
		dstXo,		// x-coordinate of UPPER-left corner of dest. rect.
		dstYo,		// y-coordinate of UPPER-left corner of dest. rect.
		dstXd,		// width of destination rectangle
		dstYd,		// height of destination rectangle
		srcXo,		// x-coordinate of LOWER-left corner of source rect.
		srcYo,		// y-coordinate of LOWER-left corner of source rect.
		srcXd,		// width of source rectangle
		srcYd,		// height of source rectangle
		bmp.Bp,		// address of bitmap bits
		bmp.Info'addr,	// address of bitmap info.
		0,			// usage = DIB_RGB_COLORS
		mode		// raster operation code
	);
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Graphics.CopyImage( gc, dst, src, mode )
{
	if( gc == null )	gc := this;

	if(( srcXo = src.Xo ) == null )	 srcXo = 0;
	if(( srcYo = src.Yo ) == null )	 srcYo = 0;
	if(( srcXd = src.Xd ) == null )	 srcXd = gc.Xd;
	if(( srcYd = src.Yd ) == null )	 srcYd = gc.Yd;

	if(( dstXo = dst.Xo ) == null )	 dstXo = 0;
	if(( dstYo = dst.Yo ) == null )	 dstYo = 0;
	if(( dstXd = dst.Xd ) == null )	 dstXd = srcXd;
	if(( dstYd = dst.Yd ) == null )	 dstYd = srcYd;

	if( mode'type != "integer" )
		mode := #SRCCOPY;

	//^SetStretchBltMode( .hdc, #HALFTONE );
	//^SetStretchBltMode( .hdc, #BLACKONWHITE );

	^StretchBlt(
		.hdc,		// handle to destination device context
		dstXo,		// x-coordinate of upper-left corner of dest. rect.
		dstYo,		// y-coordinate of upper-left corner of dest. rect.
		dstXd,		// width of destination rectangle
		dstYd,		// height of destination rectangle
		gc.hdc,		// handle to source device context
		srcXo,		// x-coordinate of upper-left corner of source rect.
		srcYo,		// y-coordinate of upper-left corner of source rect.
		srcXd,		// width of source rectangle
		srcYd,		// height of source rectangle
		mode		// raster operation code
	);
}

//=============================================================================

// w̃foCXReLXgƌ݊̂郁[foCXReLXg

function ::GK.Image.Construct( hDC, Xd, Yd, BW? )
{
	.hdc = ^CreateCompatibleDC( hDC );	// hDC == null ̎Aʂ DC
	.Xd = Xd;
	.Yd = Yd;

	if( BW? )	// imNjH
	{
		.Bits'UBYTE( Yd, (( Xd + 7 ) / 8 + 1 ) / 2 * 2 );
		.hBmp = ^CreateBitmap( Xd, Yd, 1, 1, .Bits );
	}
	else	// wfoCXƓF\̏ꍇ
	{
		if( hDC == null )
		{
			hDC = ^GetDC( #NULL );
			.hBmp = ^CreateCompatibleBitmap( hDC, Xd, Yd );
			^ReleaseDC( #NULL, hDC );
		}
		else
			.hBmp = ^CreateCompatibleBitmap( hDC, Xd, Yd );
	}
	.hOrgBmp = ^SelectObject( .hdc, .hBmp );
	#px "--- Image \z", .hdc;
}

function ::GK.Image.Destruct()
{
	#px "--- Image j", .hdc;
	if( .hdc != null )
	{
		.ResetPaintConds();
		^SelectObject( .hdc, .hOrgBmp );
		^DeleteDC( .hdc );
		^DeleteObject( .hBmp );
		.hdc = null;
	}
}

//-----------------------------------------------------------------------------

// ̃foCXɈˑȂ`Ԃ̃[foCXReLXg

function ::GK.VFrame.Construct( Xd, Yd, Zd, Pal )
{
	switch( Zd )
	{
	  case 1:	colors = 2;		break;
	  case 4:	colors = 16;	break;
	  case 8:	colors = 256;	break;
	  default:	Zd := 16;
	  case 16:
	  case 24:
	  case 32:	colors = 0;		break;
	}

	.Xd = Xd;
	.Yd = Yd;
	.Zd = Zd;
	.Xb = (( Xd * Zd + 7 ) / 8 + 3 ) & ~3;	// PC̃oCg
	.Bn = .Xb * Yd;		// ff[^̃TCYioCgj
	.Bp'ULONG;			// ff[^̊i[AhX

	Info'ULONG( 10 + colors ) =  // BITMAPINFO = ( BITMAPINFOHEADER + RGBQUAD[] )
	{
		( 10 + colors ) * 4,	// biSize = sizeof( BITMAPINFO )
		Xd,						// biWidth
		Yd,						// biHeight
		1 + ( Zd << 16 ),		// biPlanes, biBitCount
		#BI_RGB,				// biCompression
		.Bn,					// biSizeImage
		0,						// biXPelsPerMeter
		0,						// biYPelsPerMeter
		0,						// biClrUsed       or S
		0,						// biClrImportant
	};

	if( colors > 0 )	//ijł̃pbgl̐ݒ͌ʂH
	{
		if( Pal == null )
		{
			// O[XP[̃pbglݒ
			#set  RGBQUARD(r,g,b)  (#r<<16)|(#g<<8)|(#b)
			switch( colors )
			{
			  case 2:	d = #RGBQUARD(0xFF,0xFF,0xFF);	  break;
			  case 16:	d = #RGBQUARD(0x11,0x11,0x11);	  break;
			  case 256:	d = #RGBQUARD(0x01,0x01,0x01);	  break;
			}
			c = 0;
			for( i = 0 ; i < colors ; i++ )
			{
				Info( 10 + i ) = c;
				c += d;
			}
		}
		else
			( Info'addr + 4*10 )'memcpy( Pal'addr, 4 * colors );
	}

	.hdc = ^CreateCompatibleDC( #NULL );
	.hBmp = ^CreateDIBSection( #NULL, Info'addr, 0, .Bp'addr, #NULL, 0 );
	.hOrgBmp = ^SelectObject( .hdc, .hBmp );
	#pc "--- VFrame \z", "hdc=": .hdc'x, "hBmp=": .hBmp'x, "hOrgBmp=": .hOrgBmp'x;
}

function ::GK.VFrame.Destruct()
{
	#pc "--- VFrame j", "hdc=": .hdc'x, "hBmp=": .hBmp'x, "hOrgBmp=": .hOrgBmp'x;
	if( .hdc != null )
	{
		.ResetPaintConds();
		^SelectObject( .hdc, .hOrgBmp );
		^DeleteDC( .hdc );
		^DeleteObject( .hBmp );
		.hdc = null;
	}
}

function ::GK.VFrame.SetPalette( i, n, pal )
{
	^SetDIBColorTable( .hdc, i, n, pal'addr );
}

//-----------------------------------------------------------------------------

// w̃EBhEŜ̃foCXReLXg

function ::GK.WndView.Construct( hWnd )
{
	.hwnd = ( hWnd != null ) ? hWnd : ^GetDesktopWindow();
	.hdc = ^GetWindowDC( .hwnd );

	R'LONG(4);
	^GetWindowRect( .hwnd, R'addr );
	.Xd = R(2) - R(0);
	.Yd = R(3) - R(1);
	#pc "--- WndView \z", "hdc=": .hdc'x, "hwnd=": .hwnd'x;
}

function ::GK.WndView.Destruct()
{
	#pc "--- WndView j", "hdc=": .hdc'x, "hwnd=": .hwnd'x;
	if( .hdc != null )
	{
		.ResetPaintConds();
		^ReleaseDC( .hwnd, .hdc );
		.hdc = null;
		//.hwnd = null;
	}
}

//-----------------------------------------------------------------------------

function ::GK.Printer.Construct( hDC )
{
	if(( .hdc = hDC ) == null )
	{
		// ftH[gv^擾
		PD.Flags = #PD_RETURNDC | #PD_RETURNDEFAULT;
		if( ! ::GK.Window.PrintDialog( PD ) || ( .hdc = PD.hDC ) == null )
			return;
	}

	^PrintJob[ .hdc ] := this;
	.JobId = 0;
	.PageStartId = 0;
	.IsToAbort = #FALSE;
	#px "--- Printer \z: ", .hdc;
}

function ::GK.Printer.Destruct()
{
	#px "--- Printer j: ", .hdc;
	if( .hdc != null )
	{
		.EndPage();
		.EndDoc();
		.ResetPaintConds();
		^DeleteDC( .hdc );
		^PrintJob[ .hdc ] := null;
		delete ^PrintJob[ .hdc ];
		.hdc = null;
	}
}

function ::GK.Printer.StartDoc( DocName )
{
	if( .JobId > 0 )	// vgWu͊JnρH
		return 0;

	//DOCINFO ::=
	//{
	//	.cbSize			'LONG;
	//	.lpszDocName	'ULONG = DocName'addr;
	//	.lpszOutput		'ULONG = 0;
	//	.lpszDatatype	'ULONG = 0;
	//	.fwType			'ULONG = 0;
	//}
	//DOCINFO.cbSize = DOCINFO'size;
	//docinfo = ::Buffer( DOCINFO.cbSize );
	//docinfo.Write( DOCINFO );
	//docinfo.Seek(0);

	docinfo'ULONG(5);
	docinfo(0) = docinfo'size;
	docinfo(1) = DocName'addr;

	return .JobId = ^StartDoc( .hdc, docinfo );
	// Ԓl >0: vgWuhc, <=0: G[
}

function ::GK.Printer.EndDoc()
{
	if( .JobId > 0 )
	{
		.JobId = 0;
		return ^EndDoc( .hdc );
		// Ԓl >0: I, <=0: G[
	}
	return 0;
}

function ::GK.Printer.StartPage()
{
	if( .JobId <= 0 )
		return 0;
	if( .PageStartId > 0 )	// y[W͊JnρH
		return 0;

	return .PageStartId = ^StartPage( .hdc );
	// Ԓl >0: I, <=0: G[
}

function ::GK.Printer.EndPage()
{
	if( .PageStartId > 0 )
	{
		.PageStartId = 0;
		return ^EndPage( .hdc );
		// Ԓl >0: I, <=0: G[
	}
	return 0;
}

function ::GK.Printer.SetAbortMonitor()
{
	^SetAbortProc( .hdc, ^PrintAbortProc'addr );
}

function	^PrintAbortProc( hdc, code )
{
	Msg'ULONG( 7 );

	while( ^PeekMessage( Msg, #NULL, 0, 0, #PM_REMOVE ) )
	{
		^TranslateMessage( Msg );
		^DispatchMessage( Msg );
	}

	if( ^PrintJob[ hdc ]'exist? )
		return ! ^PrintJob[ hdc ]::IsToAbort;
	else
		return #FALSE;
}

//=============================================================================

function ::GK.Pen.Construct( color, style, width )
{
	if( style == null  &&  width == null )
	{
		switch( color )
		{
		  case null:			  .hPen = ^GetStockObject( #NULL_PEN );   return;
		  case #RGB(0,0,0):		  .hPen = ^GetStockObject( #BLACK_PEN );  return;
		  case #RGB(255,255,255): .hPen = ^GetStockObject( #WHITE_PEN );  return;
		}
	}
	if( style == null || ( style & #PS_GEOMETRIC ) == 0 )
	{
		.hPen = ^CreatePen( style, width, color );
		return;
	}

	#pc	"@@@ ExtCreatePen: ": color'x(8), style'x, width;
	lb'ULONG(3) = {  #BS_SOLID, color, 0  };	// LOGBRUSH
	.hPen = ^ExtCreatePen( style, width, lb'addr, 0, #NULL );

	//ijstyle == nulliȗjȂA i  #PS_SOLID == 0 j
	//ijwidth == nulliȗjȂA 1
	//ij 1 łȂꍇłA͖ɎɂȂȂ
}

function ::GK.Pen.Destruct()	{  ^DeleteObject( .hPen );  }
	//ijGetStockObject() Ŏ擾 .hPen ł

//-----------------------------------------------------------------------------

function ::GK.Brush.Construct( color, style )
{
	if( style == null )
	{
		switch( color )
		{
		  case null:			  .hBrush = ^GetStockObject( #NULL_BRUSH );   return;
		  case #RGB(0,0,0):		  .hBrush = ^GetStockObject( #BLACK_BRUSH );  return;
		  case #RGB(255,255,255): .hBrush = ^GetStockObject( #WHITE_BRUSH );  return;
		}
		.hBrush = ^CreateSolidBrush( color );
	}
	else
		.hBrush = ^CreateHatchBrush( style, color );
}

function ::GK.Brush.Destruct()	{  ^DeleteObject( .hBrush );  }
	//ijGetStockObject() Ŏ擾 .hBrush ł

//-----------------------------------------------------------------------------

function ::GK.Font.Construct( name, ydots, chset, pitch, style, angle )
{
	if(( id = .Stock[ name ] ) != null )
	{
		.hFont = ^GetStockObject( id );
		return;
	}
	Yd = ( ydots'type == "integer" ) ? ydots : 18;
	if( chset'type != "integer" )
		chset := #SHIFTJIS_CHARSET;		// = #DEFAULT_CHARSET;
	if( pitch'type != "integer" )
		pitch := #FIXED_PITCH;			// = #DEFAULT_PITCH;
	if( style'type != "integer" )
		style := 0;
	if( angle'type != "integer" )
		angle := 0;

	LOGFONT ::=
	{
		.Height			'LONG = -Yd;
		.Width			'LONG = 0; 
		.Escapement		'LONG = ( angle * 10 )'int;
		.Orientation	'LONG = .Escapement;
		.Weight			'LONG = ( style & ::GK.Font.BOLD ) ? 700 : 0 ;
		.Italic			'BYTE = ( style & ::GK.Font.ITALIC ) ? 1 : 0 ;
		.Underline		'BYTE = 0;		// = FALSE
		.StrikeOut		'BYTE = 0;		// = FALSE
		.CharSet		'BYTE = chset;
		.OutPrecision	'BYTE = 0;		// = OUT_DEFAULT_PRECIS
		.ClipPrecision	'BYTE = 0;		// = CLIP_DEFAULT_PRECIS
		.Quality		'BYTE = 0;		// = DEFAULT_QUALITY
		.PitchAndFamily	'BYTE = pitch;
		.FaceName		'T( #LF_FACESIZE ) = name;
	}; 

	logfont = ::Buffer( LOGFONT'size );
	logfont.Write( LOGFONT );
	logfont.Seek(0);
	.hFont = ^CreateFontIndirect( logfont );
	#px "--- Font \z", .hFont, name;
}

function ::GK.Font.Destruct()
{
	#px "--- Font j", .hFont;
	if( .hFont != null )
	{
		^DeleteObject( .hFont );
		//ijGetStockObject() Ŏ擾 .hFont ł
		.hFont = null;
	}
}

//-----------------------------------------------------------------------------

function ::GK.Point.Construct( Xo, Yo )				// _
{
	.Xo = Xo;  .Yo = Yo;
}

function ::GK.Line.Construct( Xo, Yo, Xd, Yd )		// 
{
	.Xo = Xo;  .Yo = Yo;  .Xd = Xd;  .Yd = Yd;
}

function ::GK.Rect.Construct( Xo, Yo, Xd, Yd )		// `
{
	.Xo = Xo;  .Yo = Yo;  .Xd = Xd;  .Yd = Yd;
}

function ::GK.Oval.Construct( Xo, Yo, Xd, Yd )		// ȉ~
{
	.Xo = Xo;  .Yo = Yo;  .Xd = Xd;  .Yd = Yd;
}

function ::GK.RRect.Construct( Xo, Yo, Xd, Yd, Rx, Ry )		// pۋ`
{
	.Xo = Xo;  .Yo = Yo;  .Xd = Xd;  .Yd = Yd;  .Rx = Rx;  .Ry = Ry;
}

function ::GK.Arc.Construct( Xo, Yo, Xd, Yd, Ao, Ad )		// ȉ~
{
	.Xo = Xo;  .Yo = Yo;  .Xd = Xd;  .Yd = Yd;  .Ao = Ao;  .Ad = Ad;
}

function ::GK.Pie.Construct( Xo, Yo, Xd, Yd, Ao, Ad )		// ȉ~`
{
	.Xo = Xo;  .Yo = Yo;  .Xd = Xd;  .Yd = Yd;  .Ao = Ao;  .Ad = Ad;
}

function ::GK.Polyline.Construct( P, N )		// A
{
	if( P != null )  .P <- P;			//ij_̏z͈ړ
	else			 .P 'LONG( N, 2 );
	.N = N;
}

function ::GK.Polygon.Construct( P, N, alt? )	// p`
{
	if( P != null )  .P <- P;			//ij_̏z͈ړ
	else			 .P 'LONG( N, 2 );
	.N = N;
	.alt? = alt?;
}

//-----------------------------------------------------------------------------

function ::GK.Rect.Set( Xo, Yo, Xd, Yd )		// `vf̐ݒiΕψʁj
{
	if( Xo != null )  .Xo = Xo;
	if( Yo != null )  .Yo = Yo;
	if( Xd != null )  .Xd = Xd;
	if( Yd != null )  .Yd = Yd;
}

function ::GK.Rect.Shift( xo, yo, xd, yd )		// `vf̑Εψ
{
	if( xo != null )  .Xo += xo;
	if( yo != null )  .Yo += yo;
	if( xd != null )  .Xd += xd;
	if( yd != null )  .Yd += yd;
}

function ::GK.Rect.And( R )		// {`Ǝw`Ƃ̋ʔ͈͂̋`ɐݒ
{
  // X W
	if(( d = R.Xo - .Xo ) >= 0 )	// .Xo <= R.Xo
	{
		if(( .Xd -= d ) <= 0 )			goto EMPTY;
		if( R.Xd < .Xd )
			if(( .Xd = R.Xd ) <= 0 )	goto EMPTY;
		.Xo = R.Xo;
	}
	else	// R.Xo < .Xo
	{
		if(( d += R.Xd ) <= 0 )		goto EMPTY;
		if( d < .Xd )
			.Xd = d;
		else if( .Xd <= 0 )			goto EMPTY;
		//.Xo = .Xo;
	}

  // Y W
	if(( d = R.Yo - .Yo ) >= 0 )	// .Yo <= R.Yo
	{
		if(( .Yd -= d ) <= 0 )			goto EMPTY;
		if( R.Yd < .Yd )
			if(( .Yd = R.Yd ) <= 0 )	goto EMPTY;
		.Yo = R.Yo;
	}
	else	// R.Yo < .Yo
	{
		if(( d += R.Yd ) <= 0 )		goto EMPTY;
		if( d < .Yd )
			.Yd = d;
		else if( .Yd <= 0 )			goto EMPTY;
		//.Yo = .Yo;
	}
	return #TRUE;

  EMPTY:
	.Xd = .Yd = 0;
	return #FALSE;
}

function ::GK.Rect.Or( R )		// {`Ǝw`Ƃ̕ܔ͈͂̋`ɐݒ
{
 // X W
	a = .Xo + .Xd;
	b = R.Xo + R.Xd;
	if( R.Xo < .Xo )
		.Xo = R.Xo;
	.Xd = (( a <= b ) ? b : a ) - .Xo;

  // Y W
	a = .Yo + .Yd;
	b = R.Yo + R.Yd;
	if( R.Yo < .Yo )
		.Yo = R.Yo;
	.Yd = (( a <= b ) ? b : a ) - .Yo;
}

function ::GK.Rect.Out?( R )	// {`͎w`̊Oiʔ͈͂ȂjH
{
	return ( .Xo + .Xd <= R.Xo  ||  R.Xo + R.Xd <= .Xo  ||
			 .Yo + .Yd <= R.Yo  ||  R.Yo + R.Yd <= .Yo );
}

function ::GK.Rect.In?( R )		// {`͎w`̓iSĊ܂܂jH
{
	return ( R.Xo <= .Xo  &&  .Xo + .Xd <= R.Xo + R.Xd  &&
			 R.Yo <= .Yo  &&  .Yo + .Yd <= R.Yo + R.Yd );
}

function ::GK.Rect.InPnt?( x, y )	// {`͎w_܂ނH
{
	return ( .Xo <= x  &&  x < .Xo + .Xd  &&  .Yo <= y  &&  y < .Yo + .Yd );
}

//-----------------------------------------------------------------------------

function ::GK.Bitmap.Setup( Xd, Yd, Zd, pBits )
{
	switch( Zd )
	{
	  case 1:	colors = 2;		break;
	  case 4:	colors = 16;	break;
	  case 8:	colors = 256;	break;
	  default:	Zd := 16;
	  case 16:
	  case 24:
	  case 32:	colors = 0;		break;
	}

	.Xd = Xd;	// f
	.Yd = Yd;	// cf
	.Zd = Zd;	// Pf̃rbg
	.Xb = (( Xd * Zd + 7 ) / 8 + 3 ) & ~3;	// PC̃oCg

	.Info'ULONG( 10 + colors ) =  // BITMAPINFO = ( BITMAPINFOHEADER + RGBQUAD[] )
	{
		40,					// biSize = sizeof( BITMAPINFOHEADER )
		Xd,					// biWidth
		Yd,					// biHeight
		1 + ( Zd << 16 ),	// biPlanes, biBitCount
		0,					// biCompression = BI_RGB
		.Xb * Yd,			// biSizeImage
		0,					// biXPelsPerMeter
		0,					// biYPelsPerMeter
		0,					// biClrUsed          or S
		0,					// biClrImportant
	};

	.Bp = pBits;		// ff[^̊i[AhX
	.Bn = .Xb * .Yd;	// ff[^̃TCYioCgj
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Bitmap.Load( file )
{
	fh = ih = 0;
	.SetStruct( fh, ih );

	f = ::File.Open( file, "in" );
	f.Read( fh, ih );

	if( fh.Type != `B`+(`M`<<8)	||
		ih.Size != 40			||
		ih.Planes != 1			||
		ih.Compression != 0 )
		goto OnFileError;

	switch( ih.BitCount )	// Pf̃rbg
	{
	  case 1:  case 4:  case 8:  case 16:  case 24:   break;
	  default:  goto OnFileError;
	}

	.Xd = ih.Width;				// f
	.Yd = ih.Height;			// cf
	.Zd = ih.BitCount;			// Pf̃rbg
	.Xb = (( .Xd * .Zd + 7 ) / 8 + 3 ) & ~3;	// PC̃oCg
	.Bn = .Xb * .Yd;			// ff[^̃TCYioCgj

	if( fh.Size < fh.OffBits + .Bn )
		goto OnFileError;

	.Info'LONG(( fh.OffBits - 14 ) / 4 );	// BITMAPINFO = ( BITMAPINFOHEADER + RGBQUAD[] )
	f.Seek( 14 );		// sizeof( BITMAPFILEHEADER ) = 14
	f.Read( .Info );

	.Pixs'UBYTE( .Bn );		// ff[^i[[
	f.Seek( fh.OffBits );
	f.Read( .Pixs );
	.Bp = .Pixs'addr;
	return;

 OnFileError:
 OnFileEnd:
	return -1;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Bitmap.Save( file )
{
	fh ::=		// BITMAPFILEHEADER
	{
		.Type		'USHORT = `B`+(`M`<<8);
		.Size		'ULONG;
		.Reserved1	'USHORT = 0;
		.Reserved2	'USHORT = 0;
		.OffBits	'ULONG;
	}
	fh.OffBits = fh'size + .Info'size;
	fh.Size = fh.OffBits + .Bn;

	f = ::File.Open( file, "out" );
	f.Write( fh, .Info, 'MEMBLK( .Bp, .Bn ) );
	return;

 OnFileError:
	return -1;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Bitmap.SetStruct( fh, ih )
{
	if( fh != null )
	{
		BITMAPFILEHEADER ::=
		{
			.Type		'USHORT;
			.Size		'ULONG;
			.Reserved1	'USHORT;
			.Reserved2	'USHORT;
			.OffBits	'ULONG;
		}
		fh <- BITMAPFILEHEADER;
	}
	if( ih != null )
	{
		BITMAPINFOHEADER ::=
		{
			.Size			'ULONG;
			.Width			'LONG;
			.Height			'LONG;
			.Planes			'USHORT;
			.BitCount		'USHORT;
			.Compression	'ULONG;
			.SizeImage		'ULONG;
			.XPelsPerMeter	'LONG;
			.YPelsPerMeter	'LONG;
			.ClrUsed		'ULONG;
			.ClrImportant	'ULONG;
		}
		ih <- BITMAPINFOHEADER;
	}
}

//-----------------------------------------------------------------------------

function ::GK.Region.Construct( R )
{
	switch( R'type )
	{
	  case "Rect":
		.hRgn = ^CreateRectRgn( R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
		break;
	  case "Oval":
		.hRgn = ^CreateEllipticRgn( R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd );
		break;
	  case "RRect":
		.hRgn = ^CreateRoundRectRgn( R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd, R.Rx, R.Ry );
		break;
	  case "Polygon":
		.hRgn = ^CreatePolygonRgn( R.P, R.N, R.alt? ? #ALTERNATE : #WINDING );
		break;
	  case "Region":
		.hRgn = ^CreateRectRgn( 0, 0, 1, 1 );
		^CombineRgn( .hRgn, R.hRgn, #NULL, #RGN_COPY );
		break;
	}
}

function ::GK.Region.Destruct()
{
	if( .hRgn )  ^DeleteObject( .hRgn );
}

operator Region A &= Region B	{  return ^CombineRgn( A.hRgn, A.hRgn, B.hRgn, #RGN_AND );  }
operator Region A |= Region B	{  return ^CombineRgn( A.hRgn, A.hRgn, B.hRgn, #RGN_OR );   }
operator Region A ^= Region B	{  return ^CombineRgn( A.hRgn, A.hRgn, B.hRgn, #RGN_XOR );  }
operator Region A -= Region B	{  return ^CombineRgn( A.hRgn, A.hRgn, B.hRgn, #RGN_DIFF ); }

//=============================================================================

