/*
===============================================================================
  MkAudio.s :  }`fBAELbgECu[ I[fBI֘A֐
===============================================================================

	Copyright (C) 2011-2012  Masahiko Watanabe
	Revision Id.:  Rev.2012.04.23

    Edition History:
      2011.08.15  GK Library ̔g`I[fBIo͊֘A{CuɈړ
      2011.08.15  g`I[fBI͕ǉ

-----------------------------------------------------------------------------*/

///  g`I[fBIo  ///


// o͏
#set	WOS_CLOSED		0
#set	WOS_OPENING		1
#set	WOS_STOPPING	2
#set	WOS_STOPPED		3
#set	WOS_PLAYING		4
#set	WOS_CLOSING		5

#set	N_WOBUF			2	// o̓obt@i_uobt@OsȂj

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Construct()
{
	#pc	"WaveOut.Construct";
	.state = #WOS_CLOSED;
	.hwo = #NULL;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Destruct()
{
	#pc	"WaveOut.Destruct: hwo = ": .hwo;
	if( .hwo )	// N[YĂȂH
	{
		// N[Yi  ͖{ׂI j
		#pc	" -- ^waveOutReset:  rv=":
		^waveOutReset( .hwo );
		#pc	" -- ^waveOutClose:  rv=":
		^waveOutClose( .hwo );
		.hwo = #NULL;
		.state = #WOS_CLOSED;
	}
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Open( 
			wnd, device, nChannels, SampleRate, SampleBits, nSamples, pause? )
{
	#pc	"WaveOut.Open: ": wnd, device, nChannels, SampleRate, SampleBits, nSamples;
	if( .hwo )	// ɃI[vρH
	{
		#pc	"  Already opened! --  hwo=": .hwo;
		return pause? ? #FALSE : .Start() ;
	}

	WAVEFORMATEX ::=
	{ 
		.wFormatTag		'USHORT	= #WAVE_FORMAT_PCM;
		.nChannels		'USHORT = nChannels;
		.nSamplesPerSec	'ULONG  = SampleRate;
		.nAvgBytesPerSec'ULONG  = nChannels * SampleBits / 8 * SampleRate;
		.nBlockAlign	'USHORT = nChannels * SampleBits / 8;
		.wBitsPerSample	'USHORT = SampleBits;
		.cbSize			'USHORT = 0;
	}
	waveformat = ::Buffer( WAVEFORMATEX'size );
	waveformat.Write( WAVEFORMATEX );
	waveformat.Seek(0);

	.nChannels  = nChannels;	// `li =1: m, =2: XeI j
	.SampleRate = SampleRate;	// TvO񐔁^b
	.SampleBits = SampleBits;	// PTvf[^̃rbg
	.nSamples   = nSamples;		// o̓obt@̃Tv
	.SampleSize = nChannels * SampleBits / 8;

	if( device'type != "integer" )
		device := #WAVE_MAPPER;

	rv = ^waveOutOpen
		( .hwo'addr, device, waveformat, wnd::hWnd, 0, #CALLBACK_WINDOW );
	if( rv != #MMSYSERR_NOERROR )
	{
		#pc	"  NG -- hwo=": .hwo, "rv=": rv;
		return -rv;
	}
	#pc	"  OK -- hwo=": .hwo, "rv=": rv;

	.owner := wnd;
	wnd::SetExtWndProc( #MM_WOM_OPEN,  .OnOpen , this );
	wnd::SetExtWndProc( #MM_WOM_CLOSE, .OnClose, this );
	wnd::SetExtWndProc( #MM_WOM_DONE,  .OnDone , this );

	.MMTIME'ULONG(3);
	.MMTIME(0) = #TIME_BYTES;		// MMTIME::wType

	.state = pause? ? #WOS_STOPPED : #WOS_OPENING;
	return #TRUE;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.OnOpen( p1, p2 )	// MM_WOM_OPEN ̃R[obN֐
{
	#pc	"WaveOut.OnOpen:  hwo=": .hwo, (( .hwo == p1 ) ? "OK" : "NG!" ), p2 ;
	// ɗ̂́AI[vȂ̂ŁAep[^͐

	// Tvf[^obt@i_uobt@j̊m
	switch( .SampleBits )
	{
	  case 8:	switch( .nChannels )
				{
				  case 1:	for( i = 0 ; i < #N_WOBUF ; i++ )
								.data[i]'UBYTE( .nSamples );
							break;
				  case 2:	for( i = 0 ; i < #N_WOBUF ; i++ )
								.data[i]'UBYTE( 2, .nSamples );
							break;
				}
				break;

	  case 16:	switch( .nChannels )
				{
				  case 1:	for( i = 0 ; i < #N_WOBUF ; i++ )
								.data[i]'SHORT( .nSamples );
							break;
				  case 2:	for( i = 0 ; i < #N_WOBUF ; i++ )
								.data[i]'SHORT( 2, .nSamples );
							break;
				}
				break;
	}

	// obt@̏i  f[^ݒ  o j
	for( i = 0 ; i < #N_WOBUF ; i++ )
	{
		.hdr[i]'ULONG( 8 );			// WAVEHDR \̗p
		.hdr[i](0) = .data[i]'addr;	// WAVEHDR::lpData 
		.hdr[i](1) = .data[i]'size;	// WAVEHDR::dwBufferLength
		//.hdr[i](2) = 0;			// WAVEHDR::dwBytesRecorded
		//.hdr[i](3) = 0;			// WAVEHDR::dwUser
		//.hdr[i](4) = 0;			// WAVEHDR::dwFlags
		.hdr[i](5) = 1;				// WAVEHDR::dwLoops
		//.hdr[i](6) = 0;			// WAVEHDR::lpNext
		//.hdr[i](7) = 0;			// WAVEHDR::reserved

		#pc	"  waveOutPrepareHeader #" : i : ": rv=":
		^waveOutPrepareHeader( .hwo, .hdr[i]'addr, #WAVEHDR_SIZE );
	}
	if( .state == #WOS_OPENING )
	{
		.state = #WOS_STOPPED;
		.Start();
	}
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Start()
{
	#pc	"WaveOut.Start: .state=": .state;
	if( .state != #WOS_STOPPED )
		return #FALSE;

	for( i = 0 ; i < #N_WOBUF ; i++ )
	{
		bn = .OnDataReq( .data[i] );
		if( bn <= 0 )
			break;

		.hdr[i](1) = bn;	// WAVEHDR::dwBufferLength
		rv = ^waveOutWrite( .hwo, .hdr[i]'addr, #WAVEHDR_SIZE );
		#pc	"waveOutWrite: buf=": i, "bn=": bn, "rv=": rv, "state=": .state;
		if( rv != #MMSYSERR_NOERROR )
			break;

		.state = #WOS_PLAYING;
		.NoMoreData? = #FALSE;
	}
	return ( .state == #WOS_PLAYING );
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Stop()
{
	#pc	"WaveOut.Stop: .state=": .state;
	if( .state != #WOS_PLAYING )
		return #FALSE;

	.state = #WOS_STOPPING;
	.Reset();
	return #TRUE;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.OnDone( p1, pHdr )	// MM_WOM_DONE ̃R[obN֐
{
	switch( .state )
	{
	  case #WOS_CLOSED:	
		#pc	"WaveOut.OnDone: state= CLOSED";
		return;

	  case #WOS_STOPPED:
		#pc	"WaveOut.OnDone: state= STOPPED";
		return;

	  case #WOS_STOPPING:
		#pc	"WaveOut.OnDone: state= STOPPING";
		for( i = 0 ; i < #N_WOBUF ; i++ )
		{
			#pc	"WAVEHDR.dwFlags = 0b": .hdr[i](4)'b(4), ".dwBufferLength = ": .hdr[i](1);
			if(( .hdr[i](4) & #WHDR_DONE ) == 0 )	// WAVEHDR::dwFlags
				return;		// o͒̃obt@cĂꍇ
		}
		.state = #WOS_STOPPED;	// Sobt@o͍
		.OnDataEnd();
		return;

	  case #WOS_PLAYING:
		if( .hwo == p1 )
		{
			for( i = 0 ; i < #N_WOBUF ; i++ )
				if( pHdr == .hdr[i]'addr )
					goto SET_DATA;
		}
		#pc	"WaveOut.OnDone: zOI -- ": .hwo, p1, pHdr;
		return;		//iɂ͗Ȃj

	  SET_DATA:
		#pc	"WaveOut.OnDone: buf=": i, .hwo, pHdr, "state=": .state, ".dwBufferLength = ": .hdr[i](1);
		if( .hdr[i](1) == 0 )	// Ō̃TCYÕf[^p̃obt@H
		{
			// Sobt@̏o
			if( .StopToClose? )		// N[YH
				goto DO_CLOSE;
			.state = #WOS_STOPPED;
			.OnDataEnd();
			return;		// I[v̂܂܂ɂĂiN[YȂj
		}
		if( .NoMoreData? )
			return;

		bn = .OnDataReq( .data[i] );
		if( bn > 0 )
		{
			.hdr[i](1) = bn;	// WAVEHDR::dwBufferLength
			rv = ^waveOutWrite( .hwo, pHdr, #WAVEHDR_SIZE );
			#pc	"waveOutWrite: buf=": i, "bn=": bn, "rv=": rv, "state=": .state;
			//if( rv != #MMSYSERR_NOERROR ) ...
			return;
		}

		// ȍ~ɏo̓f[^ꍇ
		.NoMoreData? = #TRUE;
		.StopToClose? = ( bn == 0 );	// oAN[Y邩ۂ

		// Sobt@̏o҂߂ɁATCYÕf[^Ōɏo
		.hdr[i](1) = 0;		// WAVEHDR::dwBufferLength
		rv = ^waveOutWrite( .hwo, pHdr, #WAVEHDR_SIZE );
		#pc	"waveOutWrite: buf=": i, "bn=0, rv=": rv, "state=": .state;
		return;

	  case #WOS_CLOSING:
		#pc	"WaveOut.OnDone: state= CLOSING";
		//ij̃obt@̏o͂ȂAN[Y͕ssƂȂ
	  DO_CLOSE:
		if( .Close() == #TRUE )		// N[YH
			.OnDataEnd();
		return;
	}
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Close()
{
	if( .state == #WOS_CLOSED )
	{
		#pc	"WaveOut.Close: already closed! -- hwo=": .hwo, "state=": .state;
		return 2;
	}

	rv = ^waveOutClose( .hwo );

	switch( rv )
	{
	  case #MMSYSERR_NOERROR:		// ɃN[Y
		#pc	"WaveOut.Close: OK -- rv=": rv, "hwo=": .hwo, "state=": .state;
		.state = #WOS_CLOSED;
		//ijN[YAobt@̎c肪΁A.OnDone() ɍsĂA
		//		OnClose() ɍsi ł͂܂A.hwo L j
		return 1;

	  case #WAVERR_STILLPLAYING:	// ݉go͒̂߃N[Y
		#pc	"WaveOut.Close: PENDING -- rv=": rv, "hwo=": .hwo, "state=": .state;
		.state = #WOS_CLOSING;
		^waveOutReset( .hwo );
		return 0;

	  default:						// ̗̑RŃN[Ys
		#pc	"WaveOut.Close: NG -- rv=": rv, "hwo=": .hwo, "state=": .state;
		return -1;		//iɂ͗Ȃj
	}
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.OnClose( p1, p2 )   // MM_WOM_CLOSE ̃R[obN֐
{
	#pc	"WaveOut.OnClose: hwo=": .hwo, (( .hwo == p1 ) ? "OK" : "NG!" ), "p2=": p2, "state=": .state;

	//if( .hwo != p1 )
	//	return;

	// I
	for( i = 0 ; i < #N_WOBUF ; i++ )
	{
		#pc	"  waveOutUnprepareHeader: buf=": i, "rv=":
		^waveOutUnprepareHeader( .hwo, .hdr[i]'addr, #WAVEHDR_SIZE );
	}
	delete .hdr, .data;
	.hwo = #NULL;
	.state = #WOS_CLOSED;
	return;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.OnDataReq( dp )	//iIuWFNgŃI[o[Chvj
{
	return 0;
}

function ::MK.WaveOut.OnDataEnd()		//iIuWFNgŃI[o[Chvj
{
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Reset()
{
	#pc	"WaveOut.Reset:  hwo=": .hwo, "state=": .state, "rv=":
	rv = ^waveOutReset( .hwo );
	return rv;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.GetPos( type )
{
	if( type'type == "integer" )
		.MMTIME(0) = type;
	//else ...	// ȗ or śAOƓ

	#pc	"WaveOut.GetPos:  hwo=": .hwo, "state=": .state, "rv=":
	rv = ^waveOutGetPosition( .hwo, .MMTIME, #MMTIME_SIZE );

	if( rv == #MMSYSERR_NOERROR )
		return .MMTIME(1);		// MMTIME::cb
	else
		return null;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.GetCaps( device )
{
	if( device'type != "integer" )
		device := .hwo;

	WAVEOUTCAPS ::=
	{
		.wMid			'USHORT;	// manufacturer ID
		.wPid			'USHORT;	// product ID
		.vDriverVersion	'LONG;		// version of the driver
		.szPname		'T(32);		// product name (NULL terminated string)
		.dwFormats		'ULONG;		// formats supported
		.wChannels		'USHORT;	// number of channels supported
		.wReserved1		'USHORT;	// structure packing
		.dwSupport		'ULONG;		// functionality supported by driver
	}
	sz = WAVEOUTCAPS'size;
	waveoutcaps = ::Buffer( sz );
	waveoutcaps.Keep( sz );
	if( ^waveOutGetDevCaps( device, waveoutcaps, sz ) != #MMSYSERR_NOERROR )
		return null;
	waveoutcaps.Read( WAVEOUTCAPS );
	//scope WAVEOUTCAPS
	//{
	//	#p	"wMid=": .wMid, "wPid=": .wPid, "vers.": .vDriverVersion'x(4);
	//	#p	"dwFormats=": .dwFormats'x(5), "wChannels=": .wChannels, "dwSupport=": .dwSupport;
	//	#p	"szPname=": .szPname; 
	//}
	return WAVEOUTCAPS;
}

//-----------------------------------------------------------------------------

function ::MK.WaveOut.Volume( left, right )
{
	if( left'type == "integer" )
	{
		if( right'type == "integer" )
			vol = ( left & 0xFFFF ) + ( right << 16 );
		else
			vol = left;
		return ^waveOutSetVolume( .hwo, vol );
	}
	else	// ʂ擾ꍇ
	{
		vol = 0;
		if( ^waveOutGetVolume( .hwo, vol'addr ) == #MMSYSERR_NOERROR )
			return ( vol & 0xFFFF, ( vol >> 16 ) & 0xFFFF );   // ( , E )
		else
			return null;
	}
}

//=============================================================================

///  g`I[fBI  ///

// ͏
#set	WIS_CLOSED		0
#set	WIS_OPENED		1
#set	WIS_RECORDING	2
#set	WIS_PAUSED		3
#set	WIS_ENDING		4

#set	N_WIBUF		4		// ̓obt@

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.Construct()
{
	#pc	"WaveIn.Construct";
	.state = #WIS_CLOSED;
	.hwi = #NULL;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.Destruct()
{
	#pc	"WaveIn.Destruct:  hwi=": .hwi;
	if( .hwi )	// N[YĂȂH
	{
		// IɃN[Y
		#pc	" -- ^waveInReset:  rv=":
		^waveInReset( .hwi );
		#pc	" -- ^waveInClose:  rv=":
		^waveInClose( .hwi );
		.hwi = #NULL;
	}
}

//-----------------------------------------------------------------------------

function ::MK.WaveIn.Open( wnd, device, nChannels, SampleRate, SampleBits, nSamples )
{
	#pc	"WaveIn.Open [1]: ": wnd, device, nChannels, SampleRate, SampleBits, nSamples;

	if( .hwi )	// ɃI[vρH
	{
		#pc	"WaveIn.Open [-]:  hwi=": .hwi;
		return #FALSE;
	}

	WAVEFORMATEX ::=
	{ 
		.wFormatTag		'USHORT	= #WAVE_FORMAT_PCM;
		.nChannels		'USHORT = nChannels;
		.nSamplesPerSec	'ULONG  = SampleRate;
		.nAvgBytesPerSec'ULONG  = nChannels * SampleBits / 8 * SampleRate;
		.nBlockAlign	'USHORT = nChannels * SampleBits / 8;
		.wBitsPerSample	'USHORT = SampleBits;
		.cbSize			'USHORT = 0;
	}
	waveformat = ::Buffer( WAVEFORMATEX'size );
	waveformat.Write( WAVEFORMATEX );
	waveformat.Seek(0);

	.nChannels  = nChannels;	// `li =1: m, =2: XeI j
	.SampleRate = SampleRate;	// TvO񐔁^b
	.SampleBits = SampleBits;	// PTvf[^̃rbg
	.nSamples   = nSamples;		// e̓obt@̊i[Tvi =SampleRate łPbj
	.SampleSize = nChannels * SampleBits / 8;

	if( device'type != "integer" )
		device := #WAVE_MAPPER;

	rv = ^waveInOpen
			( .hwi'addr, device, waveformat, wnd::hWnd, 0, #CALLBACK_WINDOW );
	#pc	"WaveIn.Open [2]:  hwi=": .hwi, "rv=": rv;

	if( rv != #MMSYSERR_NOERROR )
		return -rv;

	.owner := wnd;
	wnd::SetExtWndProc( #MM_WIM_OPEN,  .OnOpen , this );
	wnd::SetExtWndProc( #MM_WIM_CLOSE, .OnClose, this );
	wnd::SetExtWndProc( #MM_WIM_DATA,  .OnData , this );

	.MMTIME'ULONG(3);
	.MMTIME(0) = #TIME_BYTES;		// MMTIME::wType

	.state = #WIS_OPENED;
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.Close()
{
	#pc	"WaveIn.Close [1]:  hwi=": .hwi;
	if( ! .hwi )	// I[vĂȂH
		return #FALSE;

	rv = ^waveInClose( .hwi );
	#pc	"WaveIn.Close [2]:  rv=": rv;

	if( rv != #MMSYSERR_NOERROR )	// N[YsH
	{
		.Reset();	// ͒̎́A܂ZbgKv
		return -rv;
	}
	.hwi = #NULL;
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.Reset()
{
	#pc	"WaveIn.Reset:  hwi=": .hwi, "rv=":
	rv = ^waveInReset( .hwi );

	if( rv == #MMSYSERR_NOERROR )
		.state = #WIS_ENDING;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.Start()
{
	#pc	"WaveIn.Start:  hwi=": .hwi, "state=": .state, "rv=":
	rv = ^waveInStart( .hwi );

	if( rv == #MMSYSERR_NOERROR )
		.state = #WIS_RECORDING;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.Stop()
{
	#pc	"WaveIn.Stop:  hwi=": .hwi, "state=": .state, "rv=":
	rv = ^waveInStop( .hwi );

	if( rv == #MMSYSERR_NOERROR )
		.state = #WIS_PAUSED;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.GetPos( type )
{
	if( type'type == "integer" )
		.MMTIME(0) = type;
	//else ...	// ȗ or śAOƓ

	#pc	"WaveIn.GetPos:  hwi=": .hwi, "state=": .state, "rv=":
	rv = ^waveInGetPosition( .hwi, .MMTIME, #MMTIME_SIZE );

	if( rv == #MMSYSERR_NOERROR )
		return .MMTIME(1);		// MMTIME::cb
	else
		return null;
}

//-----------------------------------------------------------------------------

function ::MK.WaveIn.OnOpen( p1, p2 )
{
	#pc	"WaveIn.OnOpen:  hwi=": .hwi, (( .hwi == p1 ) ? "OK" : "NG!" ), p2 ;
	// ɗ̂́AI[vȂ̂ŁAep[^͐

	// Tvf[^obt@i_uobt@j̊m
	switch( .SampleBits )
	{
	  case  8:	switch( .nChannels )
				{
				  case 1:	for( i = 0 ; i < #N_WIBUF ; i++ )
								.data[i]'UBYTE( .nSamples );
							break;
				  case 2:	for( i = 0 ; i < #N_WIBUF ; i++ )
								.data[i]'UBYTE( 2, .nSamples );
							break;
				}
				break;

	  case 16:	switch( .nChannels )
				{
				  case 1:	for( i = 0 ; i < #N_WIBUF ; i++ )
								.data[i]'SHORT( .nSamples );
							break;
				  case 2:	for( i = 0 ; i < #N_WIBUF ; i++ )
								.data[i]'SHORT( 2, .nSamples );
							break;
				}
				break;
	}

	for( i = 0 ; i < #N_WIBUF ; i++ )
	{
		.hdr[i]'ULONG( 8 );			// WAVEHDR \̗p
		.hdr[i](0) = .data[i]'addr;	// WAVEHDR::lpData 
		.hdr[i](1) = .data[i]'size;	// WAVEHDR::dwBufferLength
		//.hdr[i](2) = 0;			// WAVEHDR::dwBytesRecorded
		//.hdr[i](3) = 0;			// WAVEHDR::dwUser
		//.hdr[i](4) = 0;			// WAVEHDR::dwFlags
		//.hdr[i](5) = 0;			// WAVEHDR::dwLoops
		//.hdr[i](6) = 0;			// WAVEHDR::lpNext
		//.hdr[i](7) = 0;			// WAVEHDR::reserved

		#pc	"  waveInPrepareHeader #" : i : ": rv=":
		^waveInPrepareHeader( .hwi, .hdr[i]'addr, #WAVEHDR_SIZE );

		#pc	"  waveInAddBuffer #" : i : ": rv=":
		^waveInAddBuffer( .hwi, .hdr[i]'addr, #WAVEHDR_SIZE );
	}

	#pc	"  waveInStart:  rv=":
	rv = ^waveInStart( .hwi );

	if( rv == #MMSYSERR_NOERROR )
		.state = #WIS_RECORDING;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.OnClose( p1, p2 )
{
	#pc	"WaveIn.OnClose:  hwi=": .hwi, (( .hwi == p1 ) ? "OK" : "NG!" ), "p2=": p2 ;

	delete .hdr, .data;

	.hwi = #NULL;
	.state = #WIS_CLOSED;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::MK.WaveIn.OnData( p1, pHdr )
{
	if( .hwi == p1 )
	{
		for( i = 0 ; i < #N_WIBUF ; i++ )
			if( pHdr == .hdr[i]'addr )
				goto GET_DATA;
	}
	#pc	"WaveIn.OnData: Error! -- ": .hwi, p1, pHdr;
	return;

  GET_DATA:
	#pc	"WaveIn.OnData:  i=": i, "hwi=": .hwi, "pHdr=": pHdr, "flags=0x": .hdr[i](4)'x(2) ;

	if( .hdr[i](4) & #WHDR_PREPARED )	// WAVEHDR::dwFlags
	{
		.OnDataInput( .data[i], .hdr[i](2) );	// WAVEHDR::dwBytesRecorded
		if( .state == #WIS_ENDING )
			#pc	"  waveInUnprepareHeader #" : i : ": rv=":
			^waveInUnprepareHeader( .hwi, pHdr, #WAVEHDR_SIZE );
		else
		{
			// ̃obt@͕ۗĂāAPÕobt@ēo^
			// iPobt@ߋ̃f[^QƂł悤ɂ邽߁j
			k = ( i + ( #N_WIBUF - 1 )) % #N_WIBUF;
			if( .hdr[k](4) & #WHDR_DONE )	// WAVEHDR::dwFlags
			{
				#pc	"  waveInAddBuffer:  k=" : k, "rv=":
				^waveInAddBuffer( .hwi, .hdr[k]'addr, #WAVEHDR_SIZE );
			}
		}
	}

	if( .state == #WIS_ENDING )
		#pc	"  waveIn.Close:  rv=":
		rv = ^waveInClose( .hwi );
}

//-----------------------------------------------------------------------------

function ::MK.WaveIn.OnDataInput( dp, dn )	//iIuWFNgŃI[o[Chvj
{
}

//-----------------------------------------------------------------------------

function ::MK.WaveIn.GetPrevBuf( sp )	// wobt@̂PÕobt@擾
{
	if(( i = sp'name'ixn ) != null )
	{
		#pc	"WaveIn.GetPrevBuf:  i=":
		i = ( i + ( #N_WIBUF - 1 )) % #N_WIBUF;
		if( .hdr[i]'exist?  && ( .hdr[i](4) & #WHDR_DONE ))	// WAVEHDR::dwFlags
			return ( .data[i]'ref, .hdr[i](2) );			// WAVEHDR::dwBytesRecorded
	}
	#pc	"WaveIn.GetPrevBuf:  rv=null, sp'name=": sp'name;
	return ( null, 0 );
}

//-----------------------------------------------------------------------------

function ::MK.WaveIn.GetCaps( device )
{
	if( device'type != "integer" )
		device := .hwi;

	WAVEINCAPS ::=
	{
		.wMid			'USHORT;	// manufacturer ID
		.wPid			'USHORT;	// product ID
		.vDriverVersion	'LONG;		// version of the driver
		.szPname		'T(32);		// product name (NULL terminated string)
		.dwFormats		'ULONG;		// formats supported
		.wChannels		'USHORT;	// number of channels supported
		.wReserved1		'USHORT;	// structure packing
	}
	sz = WAVEINCAPS'size;
	waveincaps = ::Buffer( sz );
	waveincaps.Keep( sz );
	if( ^waveInGetDevCaps( device, waveincaps, sz ) != #MMSYSERR_NOERROR )
		return null;
	waveincaps.Read( WAVEINCAPS );
	//scope WAVEINCAPS
	//{
	//	#p	"wMid=": .wMid, "wPid=": .wPid, "vers.": .vDriverVersion'x(4);
	//	#p	"dwFormats=": .dwFormats'x(5), "wChannels=": .wChannels;
	//	#p	"szPname=": .szPname; 
	//}
	return WAVEINCAPS;
}

//=============================================================================

