/*
===============================================================================
  NkLibrary.s :  lbg[NELbgECu[
===============================================================================

	Copyright (C) 2013  Masahiko Watanabe

    Edition History:
      2013.03.27  ŁijR[hŗpj

-----------------------------------------------------------------------------*/

/*****/  // fobOvgi[Xj
#set  pc	#comment
#set  pv
#set  ex	#comment
/*****/

/*****  // fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  ex
/*****/

#set  p		print

//#include  <GkLib\GkDefs.mh>
//#include  <GkLib\GkSysDefs.mh>
#include  <NkLib\NkDefs.mh>

//=============================================================================

function	^ModuleInit()
{
	if( ^IsNkLibInit'exist? )	// ɏݒς݁H
		return;

	#pc	"NK Library: Initialization Start!";

	^DefValue = null;	// ӁF ^DefValue ̒l͕ύXsI

	#pv	^winsock = ::DLL.Link( "Ws2_32.dll", "sys", "CP-1252" );
	if( ^winsock == #NULL )
	{
		#p	"Error: Ws2_32.dll ܂I";
		return #NG;
	}

	#pv	^WSAStartup		 = ^winsock.GetEntry( "WSAStartup" );
	#pv	^WSACleanup		 = ^winsock.GetEntry( "WSACleanup" );
	#pv	^WSAGetLastError = ^winsock.GetEntry( "WSAGetLastError" );
	#pv	^WSAAsyncSelect  = ^winsock.GetEntry( "WSAAsyncSelect" );

	#pv	^inet_addr		 = ^winsock.GetEntry( "inet_addr" );
	#pv	^inet_ntoa		 = ^winsock.GetEntry( "inet_ntoa" );
	#pv	^gethostname	 = ^winsock.GetEntry( "gethostname" );
	#pv	^gethostbyname	 = ^winsock.GetEntry( "gethostbyname" );
	#pv	^gethostbyaddr	 = ^winsock.GetEntry( "gethostbyaddr" );

	#pv	^socket			 = ^winsock.GetEntry( "socket" );
	#pv	^closesocket	 = ^winsock.GetEntry( "closesocket" );
	#pv	^bind			 = ^winsock.GetEntry( "bind" );
	#pv	^listen			 = ^winsock.GetEntry( "listen" );
	#pv	^accept			 = ^winsock.GetEntry( "accept" );
	#pv	^connect		 = ^winsock.GetEntry( "connect" );
	#pv	^shutdown		 = ^winsock.GetEntry( "shutdown" );
	#pv	^send			 = ^winsock.GetEntry( "send" );
	#pv	^recv			 = ^winsock.GetEntry( "recv" );


	#set	VersionToUse		#MAKEWORD(2,2)
	#set	WSADESCRIPTION_LEN	256
	#set	WSASYS_STATUS_LEN	128

	WSADATA ::=
	{
		.wVersion		'SHORT;
		.wHighVersion	'SHORT;
		.szDescription	'C( #WSADESCRIPTION_LEN + 1 );
		.szSystemStatus	'C( #WSASYS_STATUS_LEN + 1 );
		.iMaxSockets	'USHORT;
		.iMaxUdpDg		'USHORT;
		.lpVendorInfo	'ULONG;		// <- char*
	}
	wd_size = WSADATA'size;
	#pc	"Size of WSADATA = " : wd_size;
	#pv	wsadata = ::Buffer( wd_size );
	wsadata.Keep( wd_size );

	if(( rc = ^WSAStartup( #VersionToUse, wsadata )) != #OK )
	{
		#p	"Error #" : rc : ": WSAStartup() sI";
		return #NG;
	}
	#pc	"WSA Startup OK!";

	wsadata.Read( WSADATA );

	scope WSADATA
	{
		#pc	"WSADATA:";
		#pc	" .wVersion       = 0x" + .wVersion'x(4);
		#pc	" .wHighVersion   = 0x" + .wHighVersion'x(4);
		#pc	" .szDescription  = " + .szDescription;
		#pc	" .szSystemStatus = " + .szSystemStatus;
		#pc	" .iMaxSockets    = " + .iMaxSockets'd;
		#pc	" .iMaxUdpDg      = " + .iMaxUdpDg'd;
	//	#pc	" .lpVendorInfo   = " + .lpVendorInfo'ps;
	}

	if( #VersionToUse != WSADATA.wVersion )
	{
		#p	"Error: WinSock ver. 2.2 ڂłI";
		^WSACleanup();
		return #NG;
	}
	#pc	"WSA Initialization OK!";

	class ::NK.Socket	{}

	::NK'AddScope( ^ModuleInit'up );

	^IsNkLibInit = #TRUE;
	#pc	"NK Library: Initialization OK!";
}

//-----------------------------------------------------------------------------

function	^ModuleTerm()
{
	if( ! ^IsNkLibInit'exist? )
		return;

	delete	^winsock;
	delete	::NK;
	delete	^IsNkLibInit;

	#pc	"NK Library: Termination End!";
}

//=============================================================================

function ::NK.Socket.Construct( hSock )
{
	#pc "--- Socket \z", hSock;

	if( hSock )
		.sock = hSock;
	else
		.sock = ^socket( #AF_INET, #SOCK_STREAM, #IPPROTO_TCP );

	if( .sock == #INVALID_SOCKET )
	{
		#p	"\Pbg쐬sI--- 0x": ^WSAGetLastError()'x(8);
		delete .sock;
	}
	#ex	else
	#pc		"\Pbg쐬 -- socket = ": .sock ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::NK.Socket.Destruct()
{
	#pc "--- Socket j", .sock;

	if( .sock != null )
	{
		^closesocket( .sock );
		delete .sock;
	}
}

//-----------------------------------------------------------------------------

function ::NK.Socket.AsyncSelect( hwnd, msg, flag )
{
	return ^WSAAsyncSelect( .sock, hwnd, msg, flag );
}

//-----------------------------------------------------------------------------

function ::NK.Socket.bind( pAddr, size )		// Server p
{
	return ^bind( .sock, pAddr, size );
}

function ::NK.Socket.Bind( port )				// Server p
{
	SOCKADDR_IN ::=
	{
		.sin_family	'SHORT	= #AF_INET;
		.sin_port	'USHORT	= port'USHORT'cbo;
		.sin_addr	'ULONG	= #INADDR_ANY;
		.sin_zero	'C(8);
	}
	sa_size = SOCKADDR_IN'size;
	sockaddr_in = ::Buffer( sa_size );
	sockaddr_in.Write( SOCKADDR_IN );
	sockaddr_in.Seek(0);

	return ^bind( .sock, sockaddr_in, sa_size );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::NK.Socket.listen( n )				// Server p
{
	return ^listen( .sock, n );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::NK.Socket.accept( pAddr, pSize )		// Server p
{
	return ^accept( .sock, pAddr, pSize );
}

function ::NK.Socket.Accept()					// Server p
{
#ex	SOCKADDR_IN ::=
#ex	{
#ex		.sin_family	'SHORT;
#ex		.sin_port	'USHORT;
#ex		.sin_addr	'ULONG;
#ex		.sin_zero	'C(8);
#ex	}
#ex	sa_size = SOCKADDR_IN'size;
#ex	sockaddr_in = ::Buffer();
#ex	sockaddr_in.Keep( sa_size );

	hSockClient = ^accept( .sock, sockaddr_in, sa_size'addr );

	if( hSockClientt != #INVALID_SOCKET )
	{
		#ex	sockaddr_in.Read( SOCKADDR_IN );
		#pc	"accept()  -- socket = %d [%s]"'fmt( hSockClient, ^inet_ntoa( SOCKADDR_IN.sin_addr )'ps( , "CP-1252" ) );
	}
	else
		#p	"accept() sI --- 0x": ^WSAGetLastError()'x(8);

	return ::NK.Socket( hSockClient );
}


//-----------------------------------------------------------------------------

function ::NK.Socket.connect( pAddr, size )		// Client p
{
	return ^connect( .sock, pAddr, size );
}

function ::NK.Socket.Connect( addr, port )		// Client p
{
	switch( addr'type )
	{
	  case "string":	addr := ^inet_addr( addr );
	  case "integer":	break;
	  default:			return #SOCKET_ERROR;
	}

	SOCKADDR_IN ::=
	{
		.sin_family	'SHORT	= #AF_INET;
		.sin_port	'USHORT	= port'USHORT'cbo;
		.sin_addr	'ULONG	= addr;
		.sin_zero	'C(8);
	}

	sa_size = SOCKADDR_IN'size;
	sockaddr_in = ::Buffer( sa_size );
	sockaddr_in.Write( SOCKADDR_IN );
	sockaddr_in.Seek(0);

	return ^connect( .sock, sockaddr_in, sa_size );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::NK.Socket.shutdown( flag )			// Client p
{
	return ^shutdown( .sock, flag );
}

//-----------------------------------------------------------------------------

function ::NK.Socket.send( bp, bn, flag )
{
	return ^send( .sock, bp, bn, flag );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::NK.Socket.recv( bp, bn, flag )
{
	return ^recv( .sock, bp, bn, flag );
}

//-----------------------------------------------------------------------------

