/*
===============================================================================
  BmpView.mc :  alot@C̉摜EBhEɕ\
===============================================================================

	Copyright (C) 2008  Masahiko Watanabe

    Edition History:
      Ver.0.82  2008.01.21
		EȈՔŁiKvŏ̋@\Aו̒j
		EӁF GK Library ́ARev.2008.01.21 gp
      Ver.1.00  2013.01.31  UNICODE 

	gF
	  BmpView.mc <t@C>
	ij
		E<t@C> ɂ́Aalot@Cw
		E<t@C> ȗÃEBhEJ
		EEBhEփt@ChbOhbvƂ̉摜ɐ؂芷

-----------------------------------------------------------------------------*/

/*****    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****/   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

//#set  pc	print
#set  pc	#comment
//#set  pv	print
#set  pv
#set  p		print


#set	VSB_Xd		16			// XN[o[
#set	HSB_Yd		16			// XN[o[

#set	STD_WND_Xd	  800
#set	STD_WND_Yd	  600
#set	SML_WND_Xd	  400
#set	SML_WND_Yd	  300

#set	WM_SHOW_BMP_FILE	(#WM_APP+123)

//-----------------------------------------------------------------------------

function	Main( argc, argv )
{
	#pc	"Jn";

	^DefValue = null;
	^WhiteBrush = ::GK.Brush( #RGB(255,255,255) );
	^TextFont = ::GK.Font( "lr oSVbN", 16 );

	class ^BmpViewWindow : ::GK.Window  {}

#pv	wnd = ^BmpViewWindow( argv[0] );
	wnd.Open();

	if( argv[0] != null  &&  ! wnd.Bmp )
		wnd.ShowBmpErrorMsg();

	::GK.WindowMsgLoop();
	//delete wnd;

	#pc	"I";
}

//-----------------------------------------------------------------------------

function ^BmpViewWindow.Construct( file_path )
{
#pv	.FilePathToOpen = file_path;
	.LoadBmpFile();
	.[ ::GK.Window.Construct ]( .GetBmpWindowTitle(),
			, , .Wnd_Xd, .Wnd_Yd, , #WS_EX_CLIENTEDGE );
}

function ^BmpViewWindow.Destruct()
{
	.[ ::GK.Window.Destruct ]();
}

function ^BmpViewWindow.OnCreate()
{
	#pc	"OnCreate";

#pv	.HScrBar = .AddScrollBar( "H", ::GK.Rect( 0, 0, 0, 0 ) );
	.HScrBar.OnScroll = HScroll;

#pv	.VScrBar = .AddScrollBar( "V", ::GK.Rect( 0, 0, 0, 0 ) );
	.VScrBar.OnScroll = VScroll;

	.gc.SetFont( ^TextFont );

	::GK.DragAcceptFiles( .hWnd, #TRUE );
}

function ^BmpViewWindow.OnSize()
{
	#pc	"OnSize", .gc.Xd, .gc.Yd;

	.HScrBar.Show? = ( .Bmp  &&  .Bmp.Xd > .gc.Xd );
	.VScrBar.Show? = ( .Bmp  &&  .Bmp.Yd > .gc.Yd );

	.ViewXd = .gc.Xd - ( .VScrBar.Show? ? #VSB_Xd : 0 );
	if( .ViewXd < 0 )
		.ViewXd = 0;
	if( .ViewXo < 0  || ( .Bmp  &&  .ViewXo + .ViewXd > .Bmp.Xd ))
		.ViewXo = 0;
	#pc	.ViewXo, .ViewXd;

	.ViewYd = .gc.Yd - ( .HScrBar.Show? ? #HSB_Yd : 0 );
	if( .ViewYd < 0 )
		.ViewYd = 0;
	if( .ViewYo < 0  || ( .Bmp  &&  .ViewYo + .ViewYd > .Bmp.Yd ))
		.ViewYo = 0;
	#pc	.ViewYo, .ViewYd;

	if( .HScrBar.Show? )
	{
		.HScrBar.Move( ::GK.Rect( 0, .gc.Yd - #HSB_Yd, .ViewXd, #HSB_Yd ) );
		.HScrBar.SetRange( 0, .Bmp.Xd );
		.HScrBar.SetPageSize( .ViewXd );
		.HScrBar.SetPos( .ViewXo );
	}
	else
		.HScrBar.Move( ::GK.Rect( 0, 0, 0, 0 ) );

	if( .VScrBar.Show? )
	{
		.VScrBar.Move( ::GK.Rect( .gc.Xd - #VSB_Xd, 0, #VSB_Xd, .ViewYd ) );
		.VScrBar.SetRange( 0, .Bmp.Yd );
		.VScrBar.SetPageSize( .ViewYd );
		.VScrBar.SetPos( .ViewYo );
	}
	else
		.VScrBar.Move( ::GK.Rect( 0, 0, 0, 0 ) );
}

function ^BmpViewWindow.OnPaint()
{
	//#pc	"OnPaint";
	Rc = ::GK.Rect();
	.GetHotRect( Rc );

	if( ! .Bmp )
	{
		.gc.ClearRect( Rc, #RGB(255,255,255) );
		.gc.DrawText( ::GK.Rect( 0, 0, .gc.Xd, .gc.Yd ),
			 "t@CɃhbvƊJ܂I" );
		return;
	}

	Rv = ::GK.Rect( 0, 0, .ViewXd, .ViewYd );
	Rv.And( Rc );

	dst = .BmpRect;
	dst.Shift( , , -.ViewXo, -.ViewYo );
	if( ! dst.And( Rv ) )
		goto CLR_ALL;

	src = ::GK.Rect( Rv.Xo + .ViewXo, Rv.Yo + .ViewYo, Rv.Xd, Rv.Yd );
	if( ! src.And( .BmpRect ) )
		goto CLR_ALL;

	.gc.DrawBitmap( .Bmp, dst, src );

  CLR_REST:
	R1 = ::GK.Region( Rc );
	R2 = ::GK.Region( dst );
	switch( R1 -= R2 )
	{
	  case #COMPLEXREGION:
		#pc "COMPLEXREGION";
	  case #SIMPLEREGION:
		.gc.FillRegion( R1, ^WhiteBrush );
	}
	return;

  CLR_ALL:
	.gc.ClearRect( Rc, #RGB(255,255,255) );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^BmpViewWindow.OnHScroll( act )
{
	switch( act )
	{
	  case #SB_TOP:			Xo = 0;							break;
	  case #SB_LINEUP:		Xo = .ViewXo - .ViewXd / 16;	break;
	  case #SB_PAGEUP:		Xo = .ViewXo - .ViewXd;			break;

	  case #SB_THUMBPOSITION:
	  case #SB_THUMBTRACK:
							Xo = .HScrBar.GetSlidePos();	break;
		//ij̃Gg[̍ۂɁAprint sȂăR\[EBhE
		//		XN[ƁAXChʒu擾łȂ悤I

	  case #SB_LINEDOWN:	Xo = .ViewXo + .ViewXd / 16;	break;
	  case #SB_PAGEDOWN:	Xo = .ViewXo + .ViewXd;			break;
	  case #SB_BOTTOM:		Xo = 0xFFF`FFFF;				break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;
	}

	if( Xo > .Bmp.Xd - .ViewXd )
		Xo = .Bmp.Xd - .ViewXd;
	if( Xo < 0 )
		Xo = 0;

	if( Xo == .ViewXo )
		goto END;

	dx = .ViewXo - Xo;
	.ViewXo = Xo;
	.HScrBar.SetPos( Xo );

	.Scroll( dx, 0, ::GK.Rect( 0, 0, .ViewXd, .ViewYd ) );
	.Update();

 END:	;
//#pc	"HScroll", act, Xo;
}

function HScroll( act, pos )
{
	.owner.OnHScroll( act );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^BmpViewWindow.OnVScroll( act )
{
	switch( act )
	{
	  case #SB_TOP:			Yo = 0;							break;
	  case #SB_LINEUP:		Yo = .ViewYo - .ViewYd / 16;	break;
	  case #SB_PAGEUP:		Yo = .ViewYo - .ViewYd;			break;

	  case #SB_THUMBPOSITION:
	  case #SB_THUMBTRACK:
							Yo = .VScrBar.GetSlidePos();	break;
		//ij̃Gg[̍ۂɁAprint sȂăR\[EBhE
		//		XN[ƁAXChʒu擾łȂ悤I

	  case #SB_LINEDOWN:	Yo = .ViewYo + .ViewYd / 16;	break;
	  case #SB_PAGEDOWN:	Yo = .ViewYo + .ViewYd;			break;
	  case #SB_BOTTOM:		Yo = 0xFFF`FFFF;				break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;
	}

	if( Yo > .Bmp.Yd - .ViewYd )
		Yo = .Bmp.Yd - .ViewYd;
	if( Yo < 0 )
		Yo = 0;

	if( Yo == .ViewYo )
		goto END;

	dy = .ViewYo - Yo;
	.ViewYo = Yo;
	.VScrBar.SetPos( Yo );

	.Scroll( 0, dy, ::GK.Rect( 0, 0, .ViewXd, .ViewYd ) );
	.Update();

 END:	;
//#pc	"VScroll", act, Yo;
}

function VScroll( act, pos )
{
	.owner.OnVScroll( act );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^BmpViewWindow.OnDropFiles( hDrop )
{
	#pc	"OnDropFiles";

	file_path'USHORT( #MAX_PATH + 4 );
	::GK.DragQueryFile( hDrop, 0, file_path, #MAX_PATH );
	.FilePathToOpen = file_path'gets( -1 );
	.PostMessage( #WM_SHOW_BMP_FILE, 0, 0 );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^BmpViewWindow.OnAppMessage( iMsg, wParam, lParam )
{
	#pc	"OnAppMessage", iMsg;

	if( iMsg == #WM_SHOW_BMP_FILE )
	{
		::GK.SetForegroundWindow( .hWnd );
		.LoadBmpFile();
		.SetTitle( .GetBmpWindowTitle() );
		.InvalidateRect();
		.GetWindowRect( R'STRUCT );
		R.Xd = .Wnd_Xd;
		R.Yd = .Wnd_Yd;
		.Move( R );
		.Update();
		if( ! .Bmp )
			.ShowBmpErrorMsg();
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^BmpViewWindow.LoadBmpFile()
{
	delete .Bmp, .Wnd_Xd, .Wnd_Yd;

	.ViewXo = 0;
	.ViewYo = 0;

	if( ! .FilePathToOpen )
		goto NO_BMP;

#pv	.Bmp = ::GK.Bitmap();
	if( .Bmp.Load( .FilePathToOpen ) == -1 )
	{
		delete .Bmp;
	  NO_BMP:
		.Wnd_Xd = #SML_WND_Xd;
		.Wnd_Yd = #SML_WND_Yd;
		goto END;
	}

	.BmpRect = ::GK.Rect( 0, 0, .Bmp.Xd, .Bmp.Yd );

	R'LONG(4);
	R(2) = ::Math.min( .Bmp.Xd, #STD_WND_Xd );  // RECT.right
	R(3) = ::Math.min( .Bmp.Yd, #STD_WND_Yd );  // RECT.bottom
	if( R(3) < .Bmp.Yd )	// XN[o[vH
		R(2) += #VSB_Xd;
	if( R(2) < .Bmp.Xd )	// XN[o[vH
		R(3) += #HSB_Yd;
	if( ::GK.AdjustWindowRectEx( R,
			#WS_OVERLAPPEDWINDOW, #FALSE, #WS_EX_CLIENTEDGE ))
	{
		.Wnd_Xd = R(2) - R(0);	// = .right - .left
		.Wnd_Yd = R(3) - R(1);	// = .bottom - .top
	}
  END:  ;
#pc	"LoadBmpFile", .FilePathToOpen, .Bmp.Xd, .Bmp.Yd, .Wnd_Xd, .Wnd_Yd;
}

function ^BmpViewWindow.GetBmpWindowTitle()
{
	if( .FilePathToOpen  &&  .Bmp )
	{
		::File.GetNamePart( .FilePathToOpen, , base_name'new!, ext_name'new! );
		return base_name + ext_name + " -- BmpView";
		//return .FilePathToOpen + " -- BmpView";
	}
	else
		return "BmpView";
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^BmpViewWindow.ShowBmpErrorMsg()
{
	if( .FilePathToOpen != null )
		.MessageBox( .FilePathToOpen + "\n\nalot@CƂĊJ܂I",
			"BmpView", #MB_ICONERROR | #MB_OK );
}

//-----------------------------------------------------------------------------
