/*
===============================================================================
  SimpleClient.mc :  ȒP TCP/IP ̃NCAg
===============================================================================

	Copyright (C) 2008-2013  Masahiko Watanabe

	Edition History:
	  2008.10.20  
	  2013.03.25  Miko3ijR[hŁjpɏC
	  2013.03.28  NkLibrary gp

-----------------------------------------------------------------------------*/

/*****/    // Cu[̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <NkLib\NkDefs.mh>

	if( ::Module.Include( "GkLibrary" ) > 0  &&
		::Module.Include( "NkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // NK Library ̃\[XCN[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <NkLib\NkLibrary.mc>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

/*****/   // fobOvgi[Xj
#set  pc	#comment
#set  pv
#set  ex	#comment
/*****/

/*****   // fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  ex
/*****/

#set  p		print

//=============================================================================

#set	SERVER_PORT		27015		// T[o[̃|[gԍ

#set	WM_APP_WSA_ASYNC	(#WM_APP+123)

//-----------------------------------------------------------------------------

function  ^Main( argc, argv )
{
	#pc	"Jn";

	^DefValue = null;
	'CharEnc( "UTF-8" );

	addr_list =		// hoAhX̓Xg
	{
		"192.168.0.2",		// Local address on LAN
		"127.0.0.1",		// Loop-back address
	};

	^ServerAddr = ::Input( "T[o[̂hoAhXF", addr_list[0] , addr_list );
	if( ^ServerAddr == null )
		goto FIN;

	class ^ClientWindow : ::GK.Window  {}

#pv	^MainWnd = ^ClientWindow();
	^MainWnd.Open();
	::GK.WindowMsgLoop();

  FIN:
	delete ^MainWnd;
	#pc	"I";
	return;

  OnError:
	print ::ErrorMessage( $err_code, $err_info );
	goto FIN;
}

//=============================================================================

function ^ClientWindow.Construct()
{
	.[ ::GK.Window.Construct ]( "SimpleClient", 50, 50, 240, 120 );
}

function ^ClientWindow.Destruct()
{
	.[ ::GK.Window.Destruct ]();
}

//-----------------------------------------------------------------------------

function ^ClientWindow.OnCreate()
{
	#pc	"OnCreate";
	.StartConnection();

#pv	.SendBtn = .AddButton( "push", "M", ::GK.Rect( 20, 20, 72, 24 ) );
	.SendBtn.Disable();
	.SendBtn.OnCommand = function() { .owner.OnSendButton(); };
}

function ^ClientWindow.OnClose()
{
	#pc	"OnClose";
	.FinishConnection();
}

function ^ClientWindow.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( R'STRUCT );
	.gc.ClearRect( R, #RGB(255,255,255) );
}

//=============================================================================

function	^ClientWindow.StartConnection()
{
	#pc	"StartConnection -- Begin";

	.Socket = ::NK.Socket();
	if( ! .Socket.sock )
	{
		ErrMsg = "\Pbg쐬sI";
		goto ERR_FIN;
	}

	if( .Socket.AsyncSelect( .hWnd, #WM_APP_WSA_ASYNC,
					#FD_CONNECT | #FD_READ | #FD_WRITE | #FD_CLOSE )
			== #SOCKET_ERROR )
	{
		ErrMsg = "AsyncSelect() sI";
		goto ERR_FIN;
	}

	if( .Socket.Connect( ^ServerAddr, #SERVER_PORT ) == #SOCKET_ERROR )
	{
		if( ::NK.WSAGetLastError() != #WSAEWOULDBLOCK )
		{
			ErrMsg = "connect() sI";
			goto ERR_FIN;
		}
	}

	#pc	"StartConnection -- End";
	return #OK;

  ERR_FIN:
	delete .Socket;
	PrintWSAError( ErrMsg );
	return #NG;
}

//-----------------------------------------------------------------------------

function	^ClientWindow.FinishConnection()
{
	#pc	"FinishConnection -- Begin";

	if( ! .Socket'exist? )
		return;

	.Socket.shutdown( #SD_SEND );
	.EmptyRecvBuff();
	.Socket.shutdown( #SD_BOTH );
	delete .Socket;

	#pc	"FinishConnection -- End";
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function	^ClientWindow.EmptyRecvBuff()
{
	#set	RecvSize	1024
	RecvBuff = ::Buffer( #RecvSize );
	while(1)
	{
		switch( .Socket.recv( RecvBuff, #RecvSize, 0 ) )
		{
		  case #SOCKET_ERROR:
			if( ::NK.WSAGetLastError() == #WSAEWOULDBLOCK )
				quit;
			PrintWSAError( "MsI" );
			return #NG;
		  case 0:	// T[o[ڑꍇ
			quit;
		//default:	// ɎMꍇ
		//	continue;
		}
	}
	return #OK;
}

//-----------------------------------------------------------------------------

function	^ClientWindow.OnAppMessage( iMsg, wParam, lParam )
{
	#pc	"OnAppMessage: " : iMsg'x(8), wParam, lParam'x(8);

	if( iMsg == #WM_APP_WSA_ASYNC )
	{
		ErrCode = #WSAGETSELECTERROR( lParam );
		switch( #WSAGETSELECTEVENT( lParam ) )
		{
		  case #FD_CONNECT: .OnSocketConnect( wParam, ErrCode );   break;
		  case #FD_READ:    .OnSocketRead   ( wParam, ErrCode );   break;
		  case #FD_WRITE:   .OnSocketWrite  ( wParam, ErrCode );   break;
		  case #FD_CLOSE:   .OnSocketClose  ( wParam, ErrCode );   break;
		}
	}
}

//-----------------------------------------------------------------------------

function	^ClientWindow.OnSocketConnect( hSocket, ErrCode )
{
	#pc	"OnSocketConnect: " : ErrCode, hSocket, .Socket.sock;

	if( ErrCode )
	{
		#p "connect() sI";
		delete .Socket;
		.PostMessage( #WM_CLOSE, 0, 0 );
		return #NG;
	}

	#pc "connect() I";
	.SendBtn.Enable();
	return #OK;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function	^ClientWindow.OnSocketRead( hSocket, ErrCode )
{
	#pc	"OnSocketRead: " : ErrCode, hSocket, .Socket.sock;

	#set	RecvSize	2048
	RecvBuff = ::Buffer( #RecvSize );
	n = 0;
	while(1)
	{
		RecvBuff.Seek( n );
		RecvBuff.Keep( #RecvSize );

		switch( k = .Socket.recv( RecvBuff, #RecvSize, 0 ))
		{
		  case #SOCKET_ERROR:
			if( ::NK.WSAGetLastError() == #WSAEWOULDBLOCK )
				quit;
			PrintWSAError( "MsI" );
			return #NG;
		  case 0:	// T[o[ڑꍇ
			quit;
		  default:	// ɎMꍇ
			n += k;
			continue;
		}
	}

	RecvBuff.Seek( 0 );
	RecvBuff.Size( n );
	while(( k = RecvBuff.Read( text'LN )) > 0 )
	{
		#p	"M(%d,%d):u%sv"'fmt( k, n, text );
	}
	return #OK;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function	^ClientWindow.OnSocketWrite( hSocket, ErrCode )
{
	#pc	"OnSocketWrite: " : ErrCode, hSocket, .Socket.sock;
	return #OK;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function	^ClientWindow.OnSocketClose( hSocket, ErrCode )
{
	#pc	"OnSocketClose: " : ErrCode, hSocket, .Socket.sock;
	return #OK;
}

//-----------------------------------------------------------------------------

function	^ClientWindow.OnSendButton()
{
	#pc	"OnSendButton: ";

	if( ! .Socket'exist? )
		return;

	if( ! .SendCount'exist? )
		.SendCount = 0;

	text = "This is a eXg string #%d.\r\n"'fmt( ++.SendCount );
	txbuf = ::Buffer();
	bn = txbuf.Write( text );	//  'CharEnc ̕ŏ
	txbuf.Seek(0);

	if( .Socket.send( txbuf, bn, 0 ) == #SOCKET_ERROR )
	{
		if( ::NK.WSAGetLastError() != #WSAEWOULDBLOCK )
			goto ERR_FIN;
		#p	"ۗ(%d):u%sv"'fmt( bn, text );
	}
	else
		#p	"M(%d):u%sv"'fmt( bn, text );

	return #OK;

  ERR_FIN:
	PrintWSAError( "MG[( socket = %d )"'fmt( .Socket.sock ) );
	return #NG;
}

//-----------------------------------------------------------------------------

function	PrintWSAError( msg )
{
	#p	"Error #" : ::NK.WSAGetLastError()'d : ": " : msg;
}

//-----------------------------------------------------------------------------

