/*
===============================================================================
  SpellCheck.mc :  pP̃Xy`FbN
===============================================================================

	Copyright (C) 2013  Masahiko Watanabe

	Edition History:
	  2013.09.28  

	F
		{XNvǵA
			I͈͂́AҏWeLXgS
			I͈͂L鎞́ȂÍ͈i`͈͂j
		ɂpP̃Xy`FbNsȂAXyԈႢƔ肳ꂽP
		̐FŒFB

	ӁF
	  {XNvg̎sɂ́Aȉ̂Rt@CKv
		E ...\Tools\libhunspell.dll
		E ...\Dict\en_US.aff
		E ...\Dict\en_US.dic
	  i ... ́AEpsaly CXg[ĂtH_[ j

-----------------------------------------------------------------------------*/

#set	TINT_MISSPELL	4		// XyԈႢ̒P̒FԍiCӂɕύXj


// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set  p		print


	e := ::Epsaly;

	::File.GetNamePart( ::File.GetProgramPath(), ProgDir'new! );

	call SETUP_HUNSPELL;

	( CurCi, CurSLn ) = ( 'Ci, 'SLn );	// ʓ̌J[\ʒuۊ
	e.SetWindowCond( 4, 0 );			// ҏWEBhE̍XVꎞ֎~

	txbuf = ::Buffer();
	regex = $"\w+";			// pPɈv鐳K\
	N = 0;					// XyԈႢ̒P̐

	switch( e.GetSelType() )
	{
	  default:
	  case 0:	// ͈͑IȂ
		e.MoveTo( 0'Ci );
		e.SelectChars( e.GetFullCn()'Ci );
		e.TintSelText( 0 );		// ҏWeLXg̑SF
		txbuf.Write( e.GetFullText() );
		MinCi = 0;
	  CHK_SPELL:
		txbuf.Seek( 0 );
		for( v = txbuf.Find( regex ) ; v > 0 ; v = txbuf.FindNext() )
		{
			if( ! ^hunspell_spell( hunspell, txbuf.FoundText() ) )
			{
				if( Ew[ txbuf.FoundText()'lower ]'exist? )	// OPH
					continue;
				e.MoveTo( ( MinCi + txbuf.FoundPos() / 2 )'Ci );
				e.SelectChars( ( txbuf.FoundSize() / 2 )'DCn );
				e.TintSelText( #TINT_MISSPELL );
				N++;
			}
		}
		break;

	  case 1:	// ͈͑I
	  case 2:	// s͈͑I
		e.TintSelText( 0 );		// Ȋ͈͓SF
		txbuf.Write( e.GetSelText() );
		( MinCi, LimCi ) = e.GetSelRange( 2 );
		goto CHK_SPELL;

	  case 3:	// `͈͑I
		e.TintSelText( 0 );		// Ȋ͈͓SF
		txbuf.Write( e.GetSelText() );
		txbuf.Seek( 0 );

		( MinLi, MaxLi ) = e.GetSelRange( 0 );
		Ci'LONG( MaxLi - MinLi + 1 );
		for( Li = MinLi ; Li <= MaxLi ; Li++ )
		{
			( MinCi, LimCi ) = e.GetSelRange( 2, Li );
			Ci( Li - MinLi ) = MinCi;
		}

		Li = 0;
		offset = 0;
		for( v = txbuf.Find( regex + $"#1|\n#2" ) ; v > 0 ; v = txbuf.FindNext() )
		{
			switch( txbuf.FoundID() )
			{
			  case 1:
				if( ! ^hunspell_spell( hunspell, txbuf.FoundText() ) )
				{
					if( Ew[ txbuf.FoundText()'lower ]'exist? )	// OPH
						continue;
					e.MoveTo( ( Ci( Li ) + ( txbuf.FoundPos() - offset ) / 2 )'Ci );
					e.SelectChars( ( txbuf.FoundSize() / 2 )'DCn );
					e.TintSelText( #TINT_MISSPELL );
					N++;
				}
				continue;
			  case 2:
				Li++;
				offset = txbuf.FoundPos() + txbuf.FoundSize();
				continue;
			}
		}
		break;
	}

	e.SelectOff();
	e.MoveTo( CurCi'Ci, CurSLn'SLn );	// ʓ̃J[\ʒuɖ߂
	e.SetWindowCond( 4, 1 );			// ҏWEBhE̍XV

	call TERMINATE_HUNSPELL;

	::Inform( N'd + " ӏɃXyԈႢ܂I" );
	return;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// Xy`FbJ[ Hunspell ̃ZbgAbv

SETUP_HUNSPELL:

#pv	^HunSpell = ::DLL.Link( ProgDir + $"Tools\libhunspell.dll", , "CP-1252" );
	if( ! ^HunSpell )
	{
		::Alert( "Xy`FbJ[ Hunspell ܂I" );
		return;
	}

#pv	^hunspell_initialize   = ^HunSpell.GetEntry( "hunspell_initialize", "__cdecl" );
#pv	^hunspell_spell        = ^HunSpell.GetEntry( "hunspell_spell", "__cdecl" );
#pv	^hunspell_uninitialize = ^HunSpell.GetEntry( "hunspell_uninitialize", "__cdecl" );


#pv	aff_path = ProgDir + $"Dict\en_US.aff";
#pv	dic_path = ProgDir + $"Dict\en_US.dic";

	if( ! ::File.IsExisting( aff_path ) || ! ::File.IsExisting( dic_path ) )
	{
		::Alert( "Hunspell ̎܂I" );
		return;
	}

#pc	"hunspell_initialize() = ": 
	hunspell = ^hunspell_initialize( aff_path, dic_path );

	// OPݒ
	file = ::File.Open( ProgDir + $"Dict\ExcWords.txt", "in" );
	if( file != null )
	{
		buf = ::Buffer();
		file.Read( buf );
		buf.Seek( 0 );
		for( v = buf.Find( $"@(.+)(\n|#])" ) ; v > 0 ; v = buf.FindNext() )
		{
			Ew[ buf.FoundText( 1 )'lower ] = 0;
		}
		delete file, buf;
	}
	back;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// Xy`FbJ[ Hunspell ̏Iݒ

TERMINATE_HUNSPELL:

#pc	"hunspell_uninitialize() = ":
	^hunspell_uninitialize( hunspell );

	delete ^HunSpell;
	back;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

